#!/usr/bin/env python

import os,re

numForAnalysis = 2
sequenceFileDir  = "querySeqFiles"

file_sbatch = '''#!/bin/bash
#SBATCH --job-name=yuraiP
#SBATCH --partition=compute
#SBATCH --time=7-00:00:00
#SBATCH --mail-user="xxx.xxxx@oist.jp"
#SBATCH --mail-type=FAIL,END
#SBATCH --input=none
#SBATCH --mem=8G          # Need more memory for ML analysis
#SBATCH --cpus-per-task=2 # max 24. It corresponds to "-T 2"
#SBATCH --ntasks=1        # 1 task
#SBATCH --array=0-NUM
#SBATCH --workdir=/work/SatohU/0inoue/yuraiParallel/test_yuraiParallel

query="$(printf 010_list${SLURM_ARRAY_TASK_ID}).out"
#  echo $query > "010_list${SLURM_ARRAY_TASK_ID}.out"

for fq in `cat ${query}`
do
  ./yuraiParallel.py $fq
done
'''


dirs = os.listdir(sequenceFileDir)

countInfile = 0
countOutfile = 0
stock = []

for file in dirs:
    if countInfile % numForAnalysis == 0 and countInfile > 0:
        out = open("010_list" + str(countOutfile) + ".out", "w")
        for file1 in stock:
            out.write(file1 + "\n")
        out.close()
        countOutfile += 1;
        stock = [];
        stock.append(file)
    else:
        stock.append(file)
    countInfile +=1
out = open("010_list" + str(countOutfile) + ".out", "w")
for file1 in stock:
    out.write(file1 + "\n")
out.close()

out2 = open("020_arrayJobAA.slurm", "w")
file_sbatch1 = re.sub("NUM", str(countOutfile), file_sbatch)
out2.write(file_sbatch1)
out2.close()
