#!/usr/bin/env python

import sys
import cgi
# import cgitb; cgitb.enable()
import re, os, shutil
from collections import OrderedDict
import subprocess
import zipfile
import time
import tarfile
import glob
from socket import gethostname

#time.sleep(1)

dbAddress = ""
EMAIL_SUBJECT_PREFX = '[%s]' % gethostname()
if "sango" in EMAIL_SUBJECT_PREFX:
    dbAddress = "/work/SatohU/0inoue/db/RawDataEns91/"  ## sango
elif "inouejun-no-Mac-Pro" in EMAIL_SUBJECT_PREFX:
    dbAddress  = "/dbb/RawDataEns91/"                   ## office
elif "inouejun-no-MacBook-Pro" in EMAIL_SUBJECT_PREFX:
    dbAddress   = "/Users/junINOUEpro/db/RawDataEns91/" ## laptop
else:
    dbAddress  = "/data/dbfe/RawDataEns91/"             ## fish-evol

#print(EMAIL_SUBJECT_PREFX)
#exit()

#print ("Content-Type: text/html\n")
#print ("")


dbLinesTMP = [
              ["Saccharomyces-cerevisiae_",        "000_OnlyLongestPeps_Saccharomyces_cerevisiae.R64-1-1.pep.all.fa",                           "000_OnlyLongestCDNAs_Saccharomyces_cerevisiae.R64-1-1.cds.all.fa",                 "005_out_vsSaccharomyces-cerevisiae.txt",        ],
              ["Mnemiopsis-leidyi_",               "000_OnlyLongestPeps_Mnemiopsis_leidyi.MneLei_Aug2011.pep.all.fa",                           "000_OnlyLongestCDNAs_Mnemiopsis_leidyi.MneLei_Aug2011.cds.all.fa",                 "005_out_vsMnemiopsis-leidyi.txt",               ],
              ["Amphimedon-queenslandica_",        "000_OnlyLongestPeps_Amphimedon_queenslandica.Aqu1.pep.all.fa",                              "000_OnlyLongestCDNAs_Amphimedon_queenslandica.Aqu1.cds.all.fa",                    "005_out_vsAmphimedon-queenslandica.txt",        ],
              ["Trichoplax-adhaerens_",            "000_OnlyLongestPeps_Trichoplax_adhaerens.ASM15027v1.pep.all.fa",                            "000_OnlyLongestCDNAs_Trichoplax_adhaerens.ASM15027v1.cds.all.fa",                  "005_out_vsTrichoplax-adhaerens.txt",            ],
              ["Thelohanellus-kitauei_",           "000_OnlyLongestPeps_Thelohanellus_kitauei.ASM82789v1.pep.all.fa",                           "000_OnlyLongestCDNAs_Thelohanellus_kitauei.ASM82789v1.cds.all.fa",                 "005_out_vsThelohanellus-kitauei.txt",           ],
              ["Hydra-vulgaris_",                  "000_OnlyLongestPeps_out_prot_Hydra-vulgaris_rna.gbk.txt",                                   "000_OnlyLongestCDNAs_out_nucl_Hydra-vulgaris_rna.gbk.txt",                         "005_out_vsHydra-vulgaris.txt",                  ],
              ["Exaiptasia-pallida_",              "000_OnlyLongestPeps_out_prot_Exaiptasia-pallida_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Exaiptasia-pallida_rna.gbk.txt",                     "005_out_vsExaiptasia-pallida.txt",             ],
              ["Nematostella-vectensis_",          "000_OnlyLongestPeps_Nematostella_vectensis.ASM20922v1.pep.all.fa",                          "000_OnlyLongestCDNAs_Nematostella_vectensis.ASM20922v1.cds.all.fa",                "005_out_vsNematostella-vectensis.txt",          ],
              ["Orbicella-faveolata_",             "000_OnlyLongestPeps_out_prot_Orbicella-faveolata_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Orbicella-faveolata_rna.gbk.txt",                    "005_out_vsOrbicella-faveolata.txt",            ],
              ["Stylophora-pistillata_",           "000_OnlyLongestPeps_out_prot_Stylophora-pistillata_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Stylophora-pistillata_rna.gbk.txt",                  "005_out_vsStylophora-pistillata.txt",          ],

              ["Acropora-digitifera_",             "000_OnlyLongestPeps_out_prot_Acropora-digitifera_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Acropora-digitifera_rna.gbk.txt",                    "005_out_vsAcropora-digitifera.txt",             ],
              ["Adineta-vaga_",                    "000_OnlyLongestPeps_Adineta_vaga.AMS_PRJEB1171_v1.pep.all.fa",                              "000_OnlyLongestCDNAs_Adineta_vaga.AMS_PRJEB1171_v1.cds.all.fa",                    "005_out_vsAdineta-vaga.txt",                    ],
              ["Schistosoma-mansoni_",             "000_OnlyLongestPeps_Schistosoma_mansoni.ASM23792v2.pep.all.fa",                             "000_OnlyLongestCDNAs_Schistosoma_mansoni.ASM23792v2.cds.all.fa",                   "005_out_vsSchistosoma-mansoni.txt",             ],
              ["Capitella-teleta_",                "000_OnlyLongestPeps_Capitella_teleta.Capitella_teleta_v1.0.pep.all.fa",                     "000_OnlyLongestCDNAs_Capitella_teleta.Capitella_teleta_v1.0.cds.all.fa",           "005_out_vsCapitella-teleta.txt",                ],
              ["Helobdella-robusta_",              "000_OnlyLongestPeps_Helobdella_robusta.Helro1.pep.all.fa",                                  "000_OnlyLongestCDNAs_Helobdella_robusta.Helro1.cds.all.fa",                        "005_out_vsHelobdella-robusta.txt",              ],
              ["Notospermus-geniculatus_",         "000_OnlyLongestPeps_nge_genome_v2.0_prot.fa",                                               "000_OnlyLongestCDNAs_nge_genome_v2.0_nucl.fa",                                     "005_out_vsNotospermus-geniculatus",             ],
              ["Phoronis-australis_",              "000_OnlyLongestPeps_pau_genome_v2.0_prot.fa",                                               "000_OnlyLongestCDNAs_pau_genome_v2.0_nucl.fa",                                     "005_out_vsPhoronis-australis",                  ],
              ["Lingula-anatina_",                 "000_OnlyLongestPeps_Lingula_anatina.LinAna1.0.pep.all.fa",                                  "000_OnlyLongestCDNAs_Lingula_anatina.LinAna1.0.cds.all.fa",                        "005_out_vsLingula-anatina.txt",                 ],
              ["Octopus-bimaculoides_",            "000_OnlyLongestPeps_Octopus_bimaculoides.PRJNA270931.pep.all.fa",                           "000_OnlyLongestCDNAs_Octopus_bimaculoides.PRJNA270931.cds.all.fa",                 "005_out_vsOctopus-bimaculoides.txt",            ],
              ["Lottia-gigantea_",                 "000_OnlyLongestPeps_Lottia_gigantea.Lotgi1.pep.all.fa",                                     "000_OnlyLongestCDNAs_Lottia_gigantea.Lotgi1.cds.all.fa",                           "005_out_vsLottia-gigantea.txt",                 ],
              ["Biomphalaria-glabrata_",           "000_OnlyLongestPeps_out_prot_Biomphalaria-glabrata_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Biomphalaria-glabrata_rna.gbk.txt",                  "005_out_vsBiomphalaria-glabrata.txt",          ],
              ["Aplysia-californica_",             "000_OnlyLongestPeps_out_prot_Aplysia-californica_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Aplysia-californica_rna.gbk.txt",                    "005_out_vsAplysia-californica.txt",            ],
              ["Crassostrea-virginica_",           "000_OnlyLongestPeps_out_prot_Crassostrea-virginica_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Crassostrea-virginica_rna.gbk.txt",                  "005_out_vsCrassostrea-virginica.txt",          ],
              ["Crassostrea-gigas_",               "000_OnlyLongestPeps_Crassostrea_gigas.oyster_v9.pep.all.fa",                                "000_OnlyLongestCDNAs_Crassostrea_gigas.oyster_v9.cds.all.fa",                      "005_out_vsCrassostrea-gigas.txt",               ],
              ["Mizuhopecten-yessoensis_",         "000_OnlyLongestPeps_out_prot_Mizuhopecten-yessoensis_rna.gbk.txt",                          "000_OnlyLongestCDNAs_out_nucl_Mizuhopecten-yessoensis_rna.gbk.txt",                "005_out_vsMizuhopecten-yessoensis.txt",        ],
              ["Pinctada-fucata_",                 "000_OnlyLongestPeps_pfu_aug2.0.AA1.fasta",                                                  "000_OnlyLongestCDNAs_pfu_aug2.0.NT1.fasta",                                        "005_out_vsPinctada-fucata.txt",                 ],

              ["Priapulus-caudatus_",              "000_OnlyLongestPeps_out_prot_Priapulus-caudatus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Priapulus-caudatus_rna.gbk.txt",                     "005_out_vsPriapulus-caudatus.txt",              ],
              ["Trichinella-spiralis_",            "000_OnlyLongestPeps_Trichinella_spiralis.Tspiralis1.pep.all.fa",                            "000_OnlyLongestCDNAs_Trichinella_spiralis.Tspiralis1.cds.all.fa",                  "005_out_vsTrichinella-spiralis.txt",            ],
              ["Strongyloides-ratti_",             "000_OnlyLongestPeps_Strongyloides_ratti.S_ratti_ED321_v5_0_4.pep.all.fa",                   "000_OnlyLongestCDNAs_Strongyloides_ratti.S_ratti_ED321_v5_0_4.cds.all.fa",         "005_out_vsStrongyloides-ratti.txt",             ],
              ["Onchocerca-volvulus_",             "000_OnlyLongestPeps_Onchocerca_volvulus.ASM49940v2.pep.all.fa",                             "000_OnlyLongestCDNAs_Onchocerca_volvulus.ASM49940v2.cds.all.fa",                   "005_out_vsOnchocerca-volvulus.txt",             ],
              ["Loa-loa_",                         "000_OnlyLongestPeps_Loa_loa.Loa_loa_V3.pep.all.fa",                                         "000_OnlyLongestCDNAs_Loa_loa.Loa_loa_V3.cds.all.fa",                               "005_out_vsLoa-loa.txt",                         ],
              ["Brugia-malayi_",                   "000_OnlyLongestPeps_Brugia_malayi.Bmal-4.0.pep.all.fa",                                     "000_OnlyLongestCDNAs_Brugia_malayi.Bmal-4.0.cds.all.fa",                           "005_out_vsBrugia-malayi.txt",                   ],
              ["Pristionchus-pacificus_",          "000_OnlyLongestPeps_Pristionchus_pacificus.P_pacificus-5.0.pep.all.fa",                     "000_OnlyLongestCDNAs_Pristionchus_pacificus.P_pacificus-5.0.cds.all.fa",           "005_out_vsPristionchus-pacificus.txt",          ],
              ["Caenorhabditis-japonica_",         "000_OnlyLongestPeps_Caenorhabditis_japonica.C_japonica-7.0.1.pep.all.fa",                   "000_OnlyLongestCDNAs_Caenorhabditis_japonica.C_japonica-7.0.1.cds.all.fa",         "005_out_vsCaenorhabditis-japonica.txt",         ],
              ["Caenorhabditis-elegans_",          "000_OnlyLongestPeps_Caenorhabditis_elegans.WBcel235.pep.all.fa",                            "000_OnlyLongestCDNAs_Caenorhabditis_elegans.WBcel235.cds.all.fa",                  "005_out_vsCaenorhabditis-elegans.txt",          ],
              ["Caenorhabditis-brenneri_",         "000_OnlyLongestPeps_Caenorhabditis_brenneri.C_brenneri-6.0.1b.pep.all.fa",                  "000_OnlyLongestCDNAs_Caenorhabditis_brenneri.C_brenneri-6.0.1b.cds.all.fa",        "005_out_vsCaenorhabditis-brenneri.txt",         ],
              ["Caenorhabditis-remanei_",          "000_OnlyLongestPeps_Caenorhabditis_remanei.C_remanei-15.0.1.pep.all.fa",                    "000_OnlyLongestCDNAs_Caenorhabditis_remanei.C_remanei-15.0.1.cds.all.fa",          "005_out_vsCaenorhabditis-remanei.txt",          ],
              ["Caenorhabditis-briggsae_",         "000_OnlyLongestPeps_Caenorhabditis_briggsae.CB4.pep.all.fa",                                "000_OnlyLongestCDNAs_Caenorhabditis_briggsae.CB4.cds.all.fa",                      "005_out_vsCaenorhabditis-briggsae.txt",         ],
              ["Limulus-polyphemus_",              "000_OnlyLongestPeps_out_prot_Limulus-polyphemus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Limulus-polyphemus_rna.gbk.txt",                     "005_out_vsLimulus-polyphemus.txt",             ],
              ["Sarcoptes-scabiei_",               "000_OnlyLongestPeps_Sarcoptes_scabiei.SscaA1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Sarcoptes_scabiei.SscaA1.cds.all.fa",                         "005_out_vsSarcoptes-scabiei.txt",               ],
              ["Tetranychus-urticae_",             "000_OnlyLongestPeps_Tetranychus_urticae.ASM23943v1.pep.all.fa",                             "000_OnlyLongestCDNAs_Tetranychus_urticae.ASM23943v1.cds.all.fa",                   "005_out_vsTetranychus-urticae.txt",             ],
              ["Ixodes-scapularis_",               "000_OnlyLongestPeps_Ixodes_scapularis.IscaW1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Ixodes_scapularis.IscaW1.cds.all.fa",                         "005_out_vsIxodes-scapularis.txt",               ],
              ["Centruroides-sculpturatus_",       "000_OnlyLongestPeps_out_prot_Centruroides-sculpturatus_rna.gbk.txt",                        "000_OnlyLongestCDNAs_out_nucl_Centruroides-sculpturatus_rna.gbk.txt",              "005_out_vsCentruroides-sculpturatus.txt",      ],
              ["Parasteatoda-tepidariorum_",       "000_OnlyLongestPeps_out_prot_Parasteatoda-tepidariorum_rna.gbk.txt",                        "000_OnlyLongestCDNAs_out_nucl_Parasteatoda-tepidariorum_rna.gbk.txt",              "005_out_vsParasteatoda-tepidariorum.txt",      ],
              ["Stegodyphus-mimosarum_",           "000_OnlyLongestPeps_Stegodyphus_mimosarum_v1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Stegodyphus_mimosarum_v1.cds.all.fa",                         "005_out_vsStegodyphus-mimosarum.txt",           ],
              ["Strigamia-maritima_",              "000_OnlyLongestPeps_Strigamia_maritima.Smar1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Strigamia_maritima.Smar1.cds.all.fa",                         "005_out_vsStrigamia-maritima.txt",              ],
              ["Hyalella-azteca_",                 "000_OnlyLongestPeps_out_prot_Hyalella-azteca_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Hyalella-azteca_rna.gbk.txt",                        "005_out_vsHyalella-azteca.txt",                ],
              ["Eurytemora-affinis_",              "000_OnlyLongestPeps_out_prot_Eurytemora-affinis_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Eurytemora-affinis_rna.gbk.txt",                     "005_out_vsEurytemora-affinis.txt",             ],
              ["Lepeophtheirus-salmonis_",         "000_OnlyLongestPeps_Lepeophtheirus_salmonis.LSalAtl2s.pep.all.fa",                          "000_OnlyLongestCDNAs_Lepeophtheirus_salmonis.LSalAtl2s.cds.all.fa",                "005_out_vsLepeophtheirus-salmonis.txt",         ], 
              ["Daphnia-magna_",                   "000_OnlyLongestPeps_Daphnia_magna.daphmag2.4.pep.all.fa",                                   "000_OnlyLongestCDNAs_Daphnia_magna.daphmag2.4.cds.all.fa",                         "005_out_vsDaphnia-magna.txt",                   ], 
              ["Daphnia-pulex_",                   "000_OnlyLongestPeps_Daphnia_pulex.V1.0.pep.all.fa",                                         "000_OnlyLongestCDNAs_Daphnia_pulex.V1.0.cds.all.fa",                               "005_out_vsDaphnia-pulex.txt",                   ], 
              ["Pediculus-humanus_",               "000_OnlyLongestPeps_Pediculus_humanus.PhumU2.pep.all.fa",                                   "000_OnlyLongestCDNAs_Pediculus_humanus.PhumU2.cds.all.fa",                         "005_out_vsPediculus-humanus.txt",               ], 

##### Hexapoda 
              ["Zootermopsis-nevadensis_",         "000_OnlyLongestPeps_Zootermopsis_nevadensis.ZooNev1.0.pep.all.fa",                          "000_OnlyLongestCDNAs_Zootermopsis_nevadensis.ZooNev1.0.cds.all.fa",                "005_out_vsZootermopsis-nevadensis.txt",         ], 
              ["Cryptotermes-secundus_",           "000_OnlyLongestPeps_out_prot_Cryptotermes-secundus_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Cryptotermes-secundus_rna.gbk.txt",                  "005_out_vsCryptotermes-secundus.txt",          ],
              ["Rhodnius-prolixus_",               "000_OnlyLongestPeps_Rhodnius_prolixus.RproC3.pep.all.fa",                                   "000_OnlyLongestCDNAs_Rhodnius_prolixus.RproC3.cds.all.fa",                         "005_out_vsRhodnius-prolixus.txt",               ], 
              ["Acyrthosiphon-pisum_",             "000_OnlyLongestPeps_Acyrthosiphon_pisum.Acyr_2.0.pep.all.fa",                               "000_OnlyLongestCDNAs_Acyrthosiphon_pisum.Acyr_2.0.cds.all.fa",                     "005_out_vsAcyrthosiphon-pisum.txt",             ],
              ["Nasonia-vitripennis_",             "000_OnlyLongestPeps_Nasonia_vitripennis.Nvit_2.1.pep.all.fa",                               "000_OnlyLongestCDNAs_Nasonia_vitripennis.Nvit_2.1.cds.all.fa",                     "005_out_vsNasonia-vitripennis.txt",             ],
              ["Atta-cephalotes_",                 "000_OnlyLongestPeps_out_prot_Atta-cephalotes_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Atta-cephalotes_rna.gbk.txt",                        "005_out_vsAtta-cephalotes.txt",                 ],
              ["Solenopsis-invicta_",              "000_OnlyLongestPeps_out_prot_Solenopsis-invicta_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Solenopsis-invicta_rna.gbk.txt",                     "005_out_vsSolenopsis-invicta.txt",              ],
              ["Apis-mellifera_",                  "000_OnlyLongestPeps_Apis_mellifera.Amel_4.5.pep.all.fa",                                    "000_OnlyLongestCDNAs_Apis_mellifera.Amel_4.5.cds.all.fa",                          "005_out_vsApis-mellifera.txt",                  ],
              ["Bombus-impatiens_",                "000_OnlyLongestPeps_Bombus_impatiens.BIMP_2.0.pep.all.fa",                                  "000_OnlyLongestCDNAs_Bombus_impatiens.BIMP_2.0.cds.all.fa",                        "005_out_vsBombus-impatiens.txt",                ],
              ["Bombus-terrestris_",               "000_OnlyLongestPeps_Bombus_terrestris.Bter_1.0.pep.all.fa",                                 "000_OnlyLongestCDNAs_Bombus_terrestris.Bter_1.0.cds.all.fa",                       "005_out_vsBombus-terrestris.txt",               ],
              ["Tribolium-castaneum_",              "000_OnlyLongestPeps_Tribolium_castaneum.Tcas5.2.pep.all.fa",                               "000_OnlyLongestCDNAs_Tribolium_castaneum.Tcas5.2.cds.all.fa",                      "005_out_vsTribolium-castaneum.txt",             ],
              ["Anoplophora-glabripennis_",         "000_OnlyLongestPeps_Anoplophora_glabripennis.Agla_1.0.pep.all.fa",                         "000_OnlyLongestCDNAs_Anoplophora_glabripennis.Agla_1.0.cds.all.fa",                "005_out_vsAnoplophora-glabripennis.txt",        ],
              ["Dendroctonus-ponderosae_",          "000_OnlyLongestPeps_Dendroctonus_ponderosae.DendPond_male_1.0.pep.all.fa",                 "000_OnlyLongestCDNAs_Dendroctonus_ponderosae.DendPond_male_1.0.cds.all.fa",        "005_out_vsDendroctonus-ponderosae.txt",         ],
              ["Bombyx-mori_",                     "000_OnlyLongestPeps_Bombyx_mori.ASM15162v1.pep.all.fa",                                     "000_OnlyLongestCDNAs_Bombyx_mori.ASM15162v1.cds.all.fa",                           "005_out_vsBombyx-mori.txt",                     ],
              ["Heliconius-melpomene_",            "000_OnlyLongestPeps_Heliconius_melpomene.Hmel1.pep.all.fa",                                 "000_OnlyLongestCDNAs_Heliconius_melpomene.Hmel1.cds.all.fa",                       "005_out_vsHeliconius-melpomene.txt",            ],
              ["Danaus-plexippus_",                "000_OnlyLongestPeps_Danaus_plexippus.Dpv3.pep.all.fa",                                      "000_OnlyLongestCDNAs_Danaus_plexippus.Dpv3.cds.all.fa",                            "005_out_vsDanaus-plexippus.txt",                ],
              ["Melitaea-cinxia_",                 "000_OnlyLongestPeps_Melitaea_cinxia.MelCinx1.0.pep.all.fa",                                 "000_OnlyLongestCDNAs_Melitaea_cinxia.MelCinx1.0.cds.all.fa",                       "005_out_vsMelitaea-cinxia.txt",                 ],
              ["Belgica-antarctica_",              "000_OnlyLongestPeps_Belgica_antarctica.ASM77530v1.pep.all.fa",                              "000_OnlyLongestCDNAs_Belgica_antarctica.ASM77530v1.cds.all.fa",                    "005_out_vsBelgica-antarctica.txt",              ],
              ["Culex-quinquefasciatus_",          "000_OnlyLongestPeps_Culex_quinquefasciatus.CpipJ2.pep.all.fa",                              "000_OnlyLongestCDNAs_Culex_quinquefasciatus.CpipJ2.cds.all.fa",                    "005_out_vsCulex-quinquefasciatus.txt",          ],
              ["Aedes-aegypti_",                   "000_OnlyLongestPeps_Aedes_aegypti.AaegL3.pep.all.fa",                                       "000_OnlyLongestCDNAs_Aedes_aegypti.AaegL3.cds.all.fa",                             "005_out_vsAedes-aegypti.txt",                   ],
              ["Anopheles-darlingi_",              "000_OnlyLongestPeps_Anopheles_darlingi.AdarC3.pep.all.fa",                                  "000_OnlyLongestCDNAs_Anopheles_darlingi.AdarC3.cds.all.fa",                        "005_out_vsAnopheles-darlingi.txt",              ],
              ["Mayetiola-destructor_",            "000_OnlyLongestPeps_Mayetiola_destructor.Mdes_1.0.pep.all.fa",                              "000_OnlyLongestCDNAs_Mayetiola_destructor.Mdes_1.0.cds.all.fa",                    "005_out_vsMayetiola-destructor.txt",            ],
              ["Megaselia-scalaris_",              "000_OnlyLongestPeps_Megaselia_scalaris.Msca1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Megaselia_scalaris.Msca1.cds.all.fa",                         "005_out_vsMegaselia-scalaris.txt",              ],
              ["Teleopsis-dalmanni_",              "000_OnlyLongestPeps_Teleopsis_dalmanni.Tel_dalmanni_2A_v1.0.pep.all.fa",                    "000_OnlyLongestCDNAs_Teleopsis_dalmanni.Tel_dalmanni_2A_v1.0.cds.all.fa",          "005_out_vsTeleopsis-dalmanni.txt",              ],
              ["Lucilia-cuprina_",                 "000_OnlyLongestPeps_out_prot_Lucilia-cuprina_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Lucilia-cuprina_rna.gbk.txt",                        "005_out_vsLucilia-cuprina.txt",                 ],
              ["Drosophila-grimshawi_",            "000_OnlyLongestPeps_Drosophila_grimshawi.dgri_caf1.pep.all.fa",                             "000_OnlyLongestCDNAs_Drosophila_grimshawi.dgri_caf1.cds.all.fa",                   "005_out_vsDrosophila-grimshawi.txt",            ],
              ["Drosophila-mojavensis_",           "000_OnlyLongestPeps_Drosophila_mojavensis.dmoj_caf1.pep.all.fa",                            "000_OnlyLongestCDNAs_Drosophila_mojavensis.dmoj_caf1.cds.all.fa",                  "005_out_vsDrosophila-mojavensis.txt",           ],
              ["Drosophila-virilis_",              "000_OnlyLongestPeps_Drosophila_virilis.dvir_caf1.pep.all.fa",                               "000_OnlyLongestCDNAs_Drosophila_virilis.dvir_caf1.cds.all.fa",                     "005_out_vsDrosophila-virilis.txt",              ],
              ["Drosophila-willistoni_",           "000_OnlyLongestPeps_Drosophila_willistoni.dwil_caf1.pep.all.fa",                            "000_OnlyLongestCDNAs_Drosophila_willistoni.dwil_caf1.cds.all.fa",                  "005_out_vsDrosophila-willistoni.txt",           ],
              ["Drosophila-pseudoobscura_",        "000_OnlyLongestPeps_Drosophila_pseudoobscura.Dpse_3.0.pep.all.fa",                          "000_OnlyLongestCDNAs_Drosophila_pseudoobscura.Dpse_3.0.cds.all.fa",                "005_out_vsDrosophila-pseudoobscura.txt",        ],
              ["Drosophila-persimilis_",           "000_OnlyLongestPeps_Drosophila_persimilis.dper_caf1.pep.all.fa",                            "000_OnlyLongestCDNAs_Drosophila_persimilis.dper_caf1.cds.all.fa",                  "005_out_vsDrosophila-persimilis.txt",           ],
              ["Drosophila-ananassae_",            "000_OnlyLongestPeps_Drosophila_ananassae.dana_caf1.pep.all.fa",                             "000_OnlyLongestCDNAs_Drosophila_ananassae.dana_caf1.cds.all.fa",                   "005_out_vsDrosophila-ananassae.txt",            ],
              ["Drosophila-yakuba_",               "000_OnlyLongestPeps_Drosophila_yakuba.dyak_caf1.pep.all.fa",                                "000_OnlyLongestCDNAs_Drosophila_yakuba.dyak_caf1.cds.all.fa",                      "005_out_vsDrosophila-yakuba.txt",               ],
              ["Drosophila-erecta_",               "000_OnlyLongestPeps_Drosophila_erecta.dere_caf1.pep.all.fa",                                "000_OnlyLongestCDNAs_Drosophila_erecta.dere_caf1.cds.all.fa",                      "005_out_vsDrosophila-erecta.txt",               ],
              ["Drosophila-simulans_",             "000_OnlyLongestPeps_Drosophila_simulans.ASM75419v3.pep.all.fa",                             "000_OnlyLongestCDNAs_Drosophila_simulans.ASM75419v3.cds.all.fa",                   "005_out_vsDrosophila-simulans.txt",             ],
              ["Drosophila-sechellia_",            "000_OnlyLongestPeps_Drosophila_sechellia.dsec_caf1.pep.all.fa",                             "000_OnlyLongestCDNAs_Drosophila_sechellia.dsec_caf1.cds.all.fa",                   "005_out_vsDrosophila-sechellia.txt",            ],
              ["Drosophila-melanogaster_",         "000_OnlyLongestPeps_Drosophila_melanogaster.BDGP6.pep.all.fa",                              "000_OnlyLongestCDNAs_Drosophila_melanogaster.BDGP6.cds.all.fa",                    "005_out_vsDrosophila-melanogaster.txt",         ],

              ["Praesagittifera-naikaiensis_",     "Praesagittifera-naikaiensis_augustus.pna_180217c.filtered.aa.txt",                          "Praesagittifera-naikaiensis_augustus.pna_180217c.filtered.codingseq.txt",          "005_out_vsPraesagittifera-naikaiensis.txt",     ],


              ["Saccoglossus-kowalevskii_",        "000_AcornwormS_sko.prot.txt",                                                               "000_AcornwormS_sko.cds.txt",                                                       "005_out_vsSaccoglossus-kowalevskii.txt",        ],
              ["Ptychodera-flava_",                "000_AcornwormP_pfl.prot.txt",                                                               "000_AcornwormP_pfl.cds.txt",                                                       "005_out_vsPtychodera-flava.txt",                ],
              ["Strongylocentrotus-purpuratus_",   "000_OnlyLongestPeps_Strongylocentrotus_purpuratus.Spur_3.1.pep.all.fa",                     "000_OnlyLongestCDNAs_Strongylocentrotus_purpuratus.Spur_3.1.cds.all.fa",           "005_out_vsStrongylocentrotus-purpuratus.txt",   ],
              ["Acanthaster-planci_",              "000_OnlyLongestPeps_ENS_oki-cotsv1.0.EVM2a.prot",                                           "000_OnlyLongestCDNAs_ENS_oki-cotsv1.0.EVM2a.mrna",                                 "005_out_vsAcanthaster-planci.txt",              ],
              ["Acanthaster-planciGBR_",           "000_OnlyLongestPeps_ENS_gbr-cotsv1.0.EVM2a.prot",                                           "000_OnlyLongestCDNAs_ENS_gbr-cotsv1.0.EVM2a.mrna",                                 "005_out_vsAcanthaster-planciGBR.txt",           ],
              ["Branchiostoma-floridae_",          "000_OnlyLongestPeps_ENS_LanceletF_proteins.Brafl1_21954.fasta",                             "000_OnlyLongestCDNAs_ENS_LanceletF_transcripts.Brafl1_21954.fasta",                "005_out_vsBranchiostoma-floridae.txt",          ],
              ["Branchiostoma-belcheri_",          "000_OnlyLongestPeps_Branchiostoma.belcheri_v18h27.r3_ref_proteinsTranslatedP2Nfromcds.fa",  "000_OnlyLongestCDNAs_ENS_Branchiostoma.belcheri_v18h27.r3_ref_cds.fa",             "005_out_vsBranchiostoma-belcheri.txt",          ],
              ["Oikopleura-dioica_",               "000_OnlyLongestPeps_Oikopleura_peptides_reference_v1.0a.fa.txt",                            "000_OnlyLongestCDNAs_Oikopleura_transcripts_reference_v1.0.fa.txt",                "005_out_vsOikopleura-dioica.txt",               ],
              ["Botryllus-schlosseri_",            "000_PEP_start_stop_transcripts30.fa.txt",                                                   "000_CDNA_start_stop_transcripts30.fa.txt",                                         "005_out_vsBotryllus-schlosseri.txt",            ],
              ["Ciona-savignyi_",                  "000_OnlyLongestPeps_Ciona_savignyi.CSAV2.0.pep.all.fa",                                     "000_OnlyLongestCDNAs_Ciona_savignyi.CSAV2.0.cds.all.fa",                           "005_out_vsCiona-savignyi.txt",                  ],
              ["Ciona-intestinalis_",              "000_OnlyLongestPeps_Ciona_intestinalis.KH.pep.all.fa",                                      "000_OnlyLongestCDNAs_Ciona_intestinalis.KH.cds.all.fa",                            "005_out_vsCiona-intestinalis.txt",              ],
         #    ["Ciona-intestinalisKH_",            "000_OnlyLongestPeps_ENS_CionaKYOprot.fasta",                                                "000_OnlyLongestCDNAs_ENS_CionaKYO.fasta",                                          "005_out_vsCiona-intestinalisKH.txt",            ],
              ["Petromyzon-marinus_",              "000_OnlyLongestPeps_Petromyzon_marinus.Pmarinus_7.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Petromyzon_marinus.Pmarinus_7.0.cds.all.fa",                  "005_out_vsPetromyzon-marinus.txt",              ],
              ["Callorhinchus-milii_",             "000_OnlyLongestPeps_eshark_proteins.fa",                                                    "000_OnlyLongestCDNAs_eshark_transcripts.fa",                                       "005_out_vsCallorhinchus-milii.txt",             ],
              ["Rhincodon-typus_",                 "000_OnlyLongestPeps_out_prot_Rhincodon-typus_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Rhincodon-typus_rna.gbk.txt",                        "005_out_vsRhincodon-typus.txt",                ],

              ###### Actinopterygii
              ["Lepisosteus-oculatus_",            "000_OnlyLongestPeps_Lepisosteus_oculatus.LepOcu1.pep.all.fa",                               "000_OnlyLongestCDNAs_Lepisosteus_oculatus.LepOcu1.cds.all.fa",                     "005_out_vsLepisosteus-oculatus.txt",          ],
              ["Scleropages-formosus_",            "000_OnlyLongestPeps_out_prot_Scleropages-formosus_rna.gbk.txt",                             "000_OnlyLongestCDNAs_out_nucl_Scleropages-formosus_rna.gbk.txt",                   "005_out_vsScleropages-formosus.txt",          ],            
              ["Paramormyrops-kingsleyae_",        "000_OnlyLongestPeps_out_prot_Paramormyrops-kingsleyae_rna.gbk.txt",                         "000_OnlyLongestCDNAs_out_nucl_Paramormyrops-kingsleyae_rna.gbk.txt",               "005_out_vsParamormyrops-kingsleyae.txt",      ],        
              ["Clupea-harengus_",                 "000_OnlyLongestPeps_out_prot_Clupea-harengus_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Clupea-harengus_rna.gbk.txt",                        "005_out_vsClupea-harengus.txt",               ],                 
              ["Ictalurus-punctatus_",             "000_OnlyLongestPeps_out_prot_Ictalurus-punctatus_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Ictalurus-punctatus_rna.gbk.txt",                    "005_out_vsIctalurus-punctatus.txt",           ],             
              ["Astyanax-mexicanus_",              "000_OnlyLongestPeps_Astyanax_mexicanus.AstMex102.pep.all.fa",                               "000_OnlyLongestCDNAs_Astyanax_mexicanus.AstMex102.cds.all.fa",                     "005_out_vsAstyanax-mexicanus.txt",            ],
              ["Pygocentrus-nattereri_",           "000_OnlyLongestPeps_out_prot_Pygocentrus-nattereri_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Pygocentrus-nattereri_rna.gbk.txt",                  "005_out_vsPygocentrus-nattereri.txt",         ],           
              ["Danio-rerio_",                     "000_OnlyLongestPeps_Danio_rerio.GRCz10.pep.all.fa",                                         "000_OnlyLongestCDNAs_Danio_rerio.GRCz10.cds.all.fa",                               "005_out_vsDanio-rerio.txt",                   ],
              ["Sinocyclocheilus-grahami_",        "000_OnlyLongestPeps_out_prot_Sinocyclocheilus-grahami_rna.gbk.txt",                         "000_OnlyLongestCDNAs_out_nucl_Sinocyclocheilus-grahami_rna.gbk.txt",               "005_out_vsSinocyclocheilus-grahami.txt",      ],        
              ["Cyprinus-carpio_",                 "000_OnlyLongestPeps_out_prot_Cyprinus-carpio_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Cyprinus-carpio_rna.gbk.txt",                        "005_out_vsCyprinus-carpio.txt",               ],                 
              ["Esox-lucius_",                     "000_OnlyLongestPeps_out_prot_Esox-lucius_rna.gbk.txt",                                      "000_OnlyLongestCDNAs_out_nucl_Esox-lucius_rna.gbk.txt",                            "005_out_vsEsox-lucius.txt",                   ],                     
              ["Salmo-salar_",                     "000_OnlyLongestPeps_out_prot_Salmo-salar_rna.gbk.txt",                                      "000_OnlyLongestCDNAs_out_nucl_Salmo-salar_rna.gbk.txt",                            "005_out_vsSalmo-salar.txt",                   ],                     
              ["Salvelinus-alpinus_",              "000_OnlyLongestPeps_out_prot_Salvelinus-alpinus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Salvelinus-alpinus_rna.gbk.txt",                     "005_out_vsSalvelinus-alpinus.txt",            ],              
              ["Oncorhynchus-mykiss_",             "000_OnlyLongestPeps_out_prot_Oncorhynchus-mykiss_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Oncorhynchus-mykiss_rna.gbk.txt",                    "005_out_vsOncorhynchus-mykiss.txt",           ],             
              ["Oncorhynchus-tshawytscha_",        "000_OnlyLongestPeps_out_prot_Oncorhynchus-tshawytscha_rna.gbk.txt",                         "000_OnlyLongestCDNAs_out_nucl_Oncorhynchus-tshawytscha_rna.gbk.txt",               "005_out_vsOncorhynchus-tshawytscha.txt",      ],        
              ["Oncorhynchus-kisutch_",            "000_OnlyLongestPeps_out_prot_Oncorhynchus-kisutch_rna.gbk.txt",                             "000_OnlyLongestCDNAs_out_nucl_Oncorhynchus-kisutch_rna.gbk.txt",                   "005_out_vsOncorhynchus-kisutch.txt",          ],            
              ["Gadus-morhua_",                    "000_OnlyLongestPeps_Gadus_morhua.gadMor1.pep.all.fa",                                       "000_OnlyLongestCDNAs_Gadus_morhua.gadMor1.cds.all.fa",                             "005_out_vsGadus-morhua.txt",                  ],
              ["Gasterosteus-aculeatus_",          "000_OnlyLongestPeps_Gasterosteus_aculeatus.BROADS1.pep.all.fa",                             "000_OnlyLongestCDNAs_Gasterosteus_aculeatus.BROADS1.cds.all.fa",                   "005_out_vsGasterosteus-aculeatus.txt",        ],
              ["Notothenia-coriiceps_",            "000_OnlyLongestPeps_out_prot_Notothenia-coriiceps_rna.gbk.txt",                             "000_OnlyLongestCDNAs_out_nucl_Notothenia-coriiceps_rna.gbk.txt",                   "005_out_vsNotothenia-coriiceps.txt",          ],            
              ["Larimichthys-crocea_",             "000_OnlyLongestPeps_out_prot_Larimichthys-crocea_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Larimichthys-crocea_rna.gbk.txt",                    "005_out_vsLarimichthys-crocea.txt",           ],             
              ["Labrus-bergylta_",                 "000_OnlyLongestPeps_out_prot_Labrus-bergylta_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Labrus-bergylta_rna.gbk.txt",                        "005_out_vsLabrus-bergylta.txt",               ],                 
              ["Tetraodon-nigroviridis_",          "000_OnlyLongestPeps_Tetraodon_nigroviridis.TETRAODON8.pep.all.fa",                          "000_OnlyLongestCDNAs_Tetraodon_nigroviridis.TETRAODON8.cds.all.fa",                "005_out_vsTetraodon-nigroviridis.txt",        ],
              ["Takifugu-rubripes_",               "000_OnlyLongestPeps_Takifugu_rubripes.FUGU4.pep.all.fa",                                    "000_OnlyLongestCDNAs_Takifugu_rubripes.FUGU4.cds.all.fa",                          "005_out_vsTakifugu-rubripes.txt",             ],
              ["Cynoglossus-semilaevis_",          "000_OnlyLongestPeps_out_prot_Cynoglossus-semilaevis_rna.gbk.txt",                           "000_OnlyLongestCDNAs_out_nucl_Cynoglossus-semilaevis_rna.gbk.txt",                 "005_out_vsCynoglossus-semilaevis.txt",        ],          
              ["Paralichthys-olivaceus_",          "000_OnlyLongestPeps_out_prot_Paralichthys-olivaceus_rna.gbk.txt",                           "000_OnlyLongestCDNAs_out_nucl_Paralichthys-olivaceus_rna.gbk.txt",                 "005_out_vsParalichthys-olivaceus.txt",        ],          
              ["Lates-calcarifer_",                "000_OnlyLongestPeps_out_prot_Lates-calcarifer_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Lates-calcarifer_rna.gbk.txt",                       "005_out_vsLates-calcarifer.txt",              ],                
              ["Seriola-lalandi-dorsalis_",        "000_OnlyLongestPeps_out_prot_Seriola-lalandi-dorsalis_rna.gbk.txt",                         "000_OnlyLongestCDNAs_out_nucl_Seriola-lalandi-dorsalis_rna.gbk.txt",               "005_out_vsSeriola-lalandi-dorsalis.txt",      ],        
              ["Seriola-dumerili_",                "000_OnlyLongestPeps_out_prot_Seriola-dumerili_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Seriola-dumerili_rna.gbk.txt",                       "005_out_vsSeriola-dumerili.txt",              ],                
              ["Stegastes-partitus_",              "000_OnlyLongestPeps_out_prot_Stegastes-partitus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Stegastes-partitus_rna.gbk.txt",                     "005_out_vsStegastes-partitus.txt",            ],              
              ["Amphiprion-ocellaris_",            "000_OnlyLongestPeps_out_prot_Amphiprion-ocellaris_rna.gbk.txt",                             "000_OnlyLongestCDNAs_out_nucl_Amphiprion-ocellaris_rna.gbk.txt",                   "005_out_vsAmphiprion-ocellaris.txt",          ],            
              ["Acanthochromis-polyacanthus_",     "000_OnlyLongestPeps_out_prot_Acanthochromis-polyacanthus_rna.gbk.txt",                      "000_OnlyLongestCDNAs_out_nucl_Acanthochromis-polyacanthus_rna.gbk.txt",            "005_out_vsAcanthochromis-polyacanthus.txt",   ],     
              ["Oreochromis-niloticus_",           "000_OnlyLongestPeps_Oreochromis_niloticus.Orenil1.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Oreochromis_niloticus.Orenil1.0.cds.all.fa",                  "005_out_vsOreochromis-niloticus.txt",         ],
              ["Neolamprologus-brichardi_",        "000_OnlyLongestPeps_out_prot_Neolamprologus-brichardi_rna.gbk.txt",                         "000_OnlyLongestCDNAs_out_nucl_Neolamprologus-brichardi_rna.gbk.txt",               "005_out_vsNeolamprologus-brichardi",          ],
              ["Pundamilia-nyererei_",             "000_OnlyLongestPeps_out_prot_Pundamilia-nyererei_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Pundamilia-nyererei_rna.gbk.txt",                    "005_out_vsPundamilia-nyererei.txt",           ],
              ["Maylandia-zebra_",                 "000_OnlyLongestPeps_out_prot_Maylandia-zebra_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Maylandia-zebra_rna.gbk.txt",                        "005_out_vsMaylandia-zebra.txt",               ],
              ["Haplochromis-burtoni_",            "000_OnlyLongestPeps_out_prot_Haplochromis-burtoni_rna.gbk.txt",                             "000_OnlyLongestCDNAs_out_nucl_Haplochromis-burtoni_rna.gbk.txt",                   "005_out_vsHaplochromis-burtoni.txt",          ],
              ["Boleophthalmus-pectinirostris_",   "000_OnlyLongestPeps_out_prot_Boleophthalmus-pectinirostris_rna.gbk.txt",                    "000_OnlyLongestCDNAs_out_nucl_Boleophthalmus-pectinirostris_rna.gbk.txt",          "005_out_vsBoleophthalmus-pectinirostris.txt", ],   
              ["Hippocampus-comes_",               "000_OnlyLongestPeps_out_prot_Hippocampus-comes_rna.gbk.txt",                                "000_OnlyLongestCDNAs_out_nucl_Hippocampus-comes_rna.gbk.txt",                      "005_out_vsHippocampus-comes.txt",             ],               
              ["Monopterus-albus_",                "000_OnlyLongestPeps_out_prot_Monopterus-albus_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Monopterus-albus_rna.gbk.txt",                       "005_out_vsMonopterus-albus.txt",              ],                
              ["Oryzias-latipes_",                 "000_OnlyLongestPeps_Oryzias_latipes.MEDAKA1.pep.all.fa",                                    "000_OnlyLongestCDNAs_Oryzias_latipes.MEDAKA1.cds.all.fa",                          "005_out_vsOryzias-latipes.txt",               ],
              ["Oryzias-melastigma_",              "000_OnlyLongestPeps_out_prot_Oryzias-melastigma_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Oryzias-melastigma_rna.gbk.txt",                     "005_out_vsOryzias-melastigma.txt",            ],              
              ["Nothobranchius-furzeri_",          "000_OnlyLongestPeps_out_prot_Nothobranchius-furzeri_rna.gbk.txt",                           "000_OnlyLongestCDNAs_out_nucl_Nothobranchius-furzeri_rna.gbk.txt",                 "005_out_vsNothobranchius-furzeri.txt",        ],
              ["Austrofundulus-limnaeus_",         "000_OnlyLongestPeps_out_prot_Austrofundulus-limnaeus_rna.gbk.txt",                          "000_OnlyLongestCDNAs_out_nucl_Austrofundulus-limnaeus_rna.gbk.txt",                "005_out_vsAustrofundulus-limnaeus.txt",       ],
              ["Cyprinodon-variegatus_",           "000_OnlyLongestPeps_out_prot_Cyprinodon-variegatus_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Cyprinodon-variegatus_rna.gbk.txt",                  "005_out_vsCyprinodon-variegatus.txt",         ],
              ["Fundulus-heteroclitus_",           "000_OnlyLongestPeps_out_prot_Fundulus-heteroclitus_rna.gbk.txt",                            "000_OnlyLongestCDNAs_out_nucl_Fundulus-heteroclitus_rna.gbk.txt",                  "005_out_vsFundulus-heteroclitus.txt",         ],
              ["Xiphophorus-maculatus_",           "000_OnlyLongestPeps_Xiphophorus_maculatus.Xipmac4.4.2.pep.all.fa",                          "000_OnlyLongestCDNAs_Xiphophorus_maculatus.Xipmac4.4.2.cds.all.fa",                "005_out_vsXiphophorus-maculatus.txt",         ],
              ["Poecilia-formosa_",                "000_OnlyLongestPeps_Poecilia_formosa.PoeFor_5.1.2.pep.all.fa",                              "000_OnlyLongestCDNAs_Poecilia_formosa.PoeFor_5.1.2.cds.all.fa",                    "005_out_vsPoecilia-formosa.txt",              ],
              ["Poecilia-reticulata_",             "000_OnlyLongestPeps_out_prot_Poecilia-reticulata_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Poecilia-reticulata_rna.gbk.txt",                    "005_out_vsPoecilia-reticulata.txt",           ],


              ##### Sarcopterygii
              ["Latimeria-chalumnae_",             "000_OnlyLongestPeps_Latimeria_chalumnae.LatCha1.pep.all.fa",                                "000_OnlyLongestCDNAs_Latimeria_chalumnae.LatCha1.cds.all.fa",                      "005_out_vsLatimeria-chalumnae.txt",             ],

              ["Xenopus-tropicalis_",              "000_OnlyLongestPeps_Xenopus_tropicalis.JGI_4.2.pep.all.fa",                                 "000_OnlyLongestCDNAs_Xenopus_tropicalis.JGI_4.2.cds.all.fa",                       "005_out_vsXenopus-tropicalis.txt",              ],
              ["Xenopus-laevis_",                  "000_OnlyLongestPeps_out_prot_Xenopus-laevis_rna.gbk.txt",                                   "000_OnlyLongestCDNAs_out_nucl_Xenopus-laevis_rna.gbk.txt",                         "005_out_vsXenopus-laevis.txt",                 ],

              ["Gekko-japonicus_",                 "000_OnlyLongestPeps_out_prot_Gekko-japonicus_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Gekko-japonicus_rna.gbk.txt",                        "005_out_vsGekko-japonicus.txt",                ],
              ["Anolis-carolinensis_",             "000_OnlyLongestPeps_Anolis_carolinensis.AnoCar2.0.pep.all.fa",                              "000_OnlyLongestCDNAs_Anolis_carolinensis.AnoCar2.0.cds.all.fa",                    "005_out_vsAnolis-carolinensis.txt",             ],
              ["Pogona-vitticeps_",                "000_OnlyLongestPeps_out_prot_Pogona-vitticeps_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Pogona-vitticeps_rna.gbk.txt",                       "005_out_vsPogona-vitticeps.txt",               ],
              ["Python-bivittatus_",               "000_OnlyLongestPeps_out_prot_Python-bivittatus_rna.gbk.txt",                                "000_OnlyLongestCDNAs_out_nucl_Python-bivittatus_rna.gbk.txt",                      "005_out_vsPython-bivittatus.txt",              ],
              ["Thamnophis-sirtalis_",             "000_OnlyLongestPeps_out_prot_Thamnophis-sirtalis_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Thamnophis-sirtalis_rna.gbk.txt",                    "005_out_vsThamnophis-sirtalis.txt",            ],
              ["Protobothrops-mucrosquamatus_",    "000_OnlyLongestPeps_out_prot_Protobothrops-mucrosquamatus_rna.gbk.txt",                     "000_OnlyLongestCDNAs_out_nucl_Protobothrops-mucrosquamatus_rna.gbk.txt",           "005_out_vsProtobothrops-mucrosquamatus.txt",   ],
              ["Pelodiscus-sinensis_",             "000_OnlyLongestPeps_Pelodiscus_sinensis.PelSin_1.0.pep.all.fa",                             "000_OnlyLongestCDNAs_Pelodiscus_sinensis.PelSin_1.0.cds.all.fa",                   "005_out_vsPelodiscus-sinensis.txt",             ],
              ["Chrysemys-picta_",                 "000_OnlyLongestPeps_out_prot_Chrysemys-picta_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Chrysemys-picta_rna.gbk.txt",                        "005_out_vsChrysemys-picta.txt",                 ],
              ["Chelonia-mydas_",                  "000_OnlyLongestPeps_out_prot_Chelonia-mydas_rna.gbk.txt",                                   "000_OnlyLongestCDNAs_out_nucl_Chelonia-mydas_rna.gbk.txt",                         "005_out_vsChelonia-mydas.txt",                  ],
              ["Alligator-mississippiensis_",      "000_OnlyLongestPeps_out_prot_Alligator-mississippiensis_rna.gbk.txt",                       "000_OnlyLongestCDNAs_out_nucl_Alligator-mississippiensis_rna.gbk.txt",             "005_out_vsAlligator-mississippiensis.txt",      ],
              ["Alligator-sinensis_",              "000_OnlyLongestPeps_out_prot_Alligator-sinensis_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Alligator-sinensis_rna.gbk.txt",                     "005_out_vsAlligator-sinensis.txt",              ],
              ["Ficedula-albicollis_",             "000_OnlyLongestPeps_Ficedula_albicollis.FicAlb_1.4.pep.all.fa",                             "000_OnlyLongestCDNAs_Ficedula_albicollis.FicAlb_1.4.cds.all.fa",                   "005_out_vsFicedula-albicollis.txt",             ],
              ["Anas-platyrhynchos_",              "000_OnlyLongestPeps_Anas_platyrhynchos.BGI_duck_1.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Anas_platyrhynchos.BGI_duck_1.0.cds.all.fa",                  "005_out_vsAnas-platyrhynchos.txt",              ],
              ["Meleagris-gallopavo_",             "000_OnlyLongestPeps_Meleagris_gallopavo.UMD2.pep.all.fa",                                   "000_OnlyLongestCDNAs_Meleagris_gallopavo.UMD2.cds.all.fa",                         "005_out_vsMeleagris-gallopavo.txt",             ],
              ["Taeniopygia-guttata_",             "000_OnlyLongestPeps_Taeniopygia_guttata.taeGut3.2.4.pep.all.fa",                            "000_OnlyLongestCDNAs_Taeniopygia_guttata.taeGut3.2.4.cds.all.fa",                  "005_out_vsTaeniopygia-guttata.txt",             ],
              ["Gallus-gallus_",                   "000_OnlyLongestPeps_Gallus_gallus.Gallus_gallus-5.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Gallus_gallus.Gallus_gallus-5.0.cds.all.fa",                  "005_out_vsGallus-gallus.txt",                   ],

              ["Ornithorhynchus-anatinus_",        "000_OnlyLongestPeps_Ornithorhynchus_anatinus.OANA5.pep.all.fa",                             "000_OnlyLongestCDNAs_Ornithorhynchus_anatinus.OANA5.cds.all.fa",                   "005_out_vsOrnithorhynchus-anatinus.txt",        ],
              ["Monodelphis-domestica_",           "000_OnlyLongestPeps_Monodelphis_domestica.monDom5.pep.all.fa",                              "000_OnlyLongestCDNAs_Monodelphis_domestica.monDom5.cds.all.fa",                    "005_out_vsMonodelphis-domestica.txt",           ],
              ["Sarcophilus-harrisii_",            "000_OnlyLongestPeps_Sarcophilus_harrisii.DEVIL7.0.pep.all.fa",                              "000_OnlyLongestCDNAs_Sarcophilus_harrisii.DEVIL7.0.cds.all.fa",                    "005_out_vsSarcophilus-harrisii.txt",            ],
              ["Notamacropus-eugenii_",            "000_OnlyLongestPeps_Notamacropus_eugenii.Meug_1.0.pep.all.fa",                              "000_OnlyLongestCDNAs_Notamacropus_eugenii.Meug_1.0.cds.all.fa",                    "005_out_vsNotamacropus-eugenii.txt",            ],
              ["Loxodonta-africana_",              "000_OnlyLongestPeps_Loxodonta_africana.loxAfr3.pep.all.fa",                                 "000_OnlyLongestCDNAs_Loxodonta_africana.loxAfr3.cds.all.fa",                       "005_out_vsLoxodonta-africana.txt",              ],
              ["Trichechus-manatus_",              "000_OnlyLongestPeps_out_prot_Trichechus-manatus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Trichechus-manatus_rna.gbk.txt",                     "005_out_vsTrichechus-manatus.txt",             ],
              ["Procavia-capensis_",               "000_OnlyLongestPeps_Procavia_capensis.proCap1.pep.all.fa",                                  "000_OnlyLongestCDNAs_Procavia_capensis.proCap1.cds.all.fa",                        "005_out_vsProcavia-capensis.txt",               ],
              ["Orycteropus-afer_",                "000_OnlyLongestPeps_out_prot_Orycteropus-afer_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Orycteropus-afer_rna.gbk.txt",                       "005_out_vsOrycteropus-afer.txt",               ],
              ["Echinops-telfairi_",               "000_OnlyLongestPeps_Echinops-telfairi.TENREC.pep.all.fa",                                   "000_OnlyLongestCDNAs_Echinops-telfairi.TENREC.cds.all.fa",                         "005_out_vsEchinops-telfairi.txt",               ],
              ["Dasypus-novemcinctus_",            "000_OnlyLongestPeps_Dasypus_novemcinctus.Dasnov3.0.pep.all.fa",                             "000_OnlyLongestCDNAs_Dasypus_novemcinctus.Dasnov3.0.cds.all.fa",                   "005_out_vsDasypus-novemcinctus.txt",            ],
              ["Choloepus-hoffmanni_",             "000_OnlyLongestPeps_Choloepus_hoffmanni.choHof1.pep.all.fa",                                "000_OnlyLongestCDNAs_Choloepus_hoffmanni.choHof1.cds.all.fa",                      "005_out_vsCholoepus-hoffmanni.txt",             ],

####Laurasiatheria
              ["Erinaceus-europaeus_",             "000_OnlyLongestPeps_Erinaceus_europaeus.HEDGEHOG.pep.all.fa",                               "000_OnlyLongestCDNAs_Erinaceus_europaeus.HEDGEHOG.cds.all.fa",                     "005_out_vsErinaceus-europaeus.txt",      ],
              ["Sorex-araneus_",                   "000_OnlyLongestPeps_Sorex_araneus.COMMON_SHREW1.pep.all.fa",                                "000_OnlyLongestCDNAs_Sorex_araneus.COMMON_SHREW1.cds.all.fa",                      "005_out_vsSorex-araneus.txt",            ],
              ["Pteropus-vampyrus_",               "000_OnlyLongestPeps_Pteropus_vampyrus.pteVam1.pep.all.fa",                                  "000_OnlyLongestCDNAs_Pteropus_vampyrus.pteVam1.cds.all.fa",                        "005_out_vsPteropus-vampyrus.txt",        ],
              ["Myotis-lucifugus_",                "000_OnlyLongestPeps_Myotis_lucifugus.Myoluc2.0.pep.all.fa",                                 "000_OnlyLongestCDNAs_Myotis_lucifugus.Myoluc2.0.cds.all.fa",                       "005_out_vsMyotis-lucifugus.txt",         ],
              ["Equus-caballus_",                  "000_OnlyLongestPeps_Equus_caballus.EquCab2.pep.all.fa",                                     "000_OnlyLongestCDNAs_Equus_caballus.EquCab2.cds.all.fa",                           "005_out_vsEquus-caballus.txt",           ],
              ["Ceratotherium-simum_",             "000_OnlyLongestPeps_out_prot_Ceratotherium-simum_rna.gbk.txt",                              "000_OnlyLongestCDNAs_out_nucl_Ceratotherium-simum_rna.gbk.txt",                    "005_out_vsCeratotherium-simum.txt",            ],
              ["Manis-javanica_",                  "000_OnlyLongestPeps_out_prot_Manis-javanica_rna.gbk.txt",                                   "000_OnlyLongestCDNAs_out_nucl_Manis-javanica_rna.gbk.txt",                         "005_out_vsManis-javanica.txt",                 ],
              ["Felis-catus_",                     "000_OnlyLongestPeps_Felis_catus.Felis_catus_8.0.pep.all.fa",                                "000_OnlyLongestCDNAs_Felis_catus.Felis_catus_8.0.cds.all.fa",                      "005_out_vsFelis-catus.txt",              ],
              ["Canis-familiaris_",                "000_OnlyLongestPeps_Canis_familiaris.CanFam3.1.pep.all.fa",                                 "000_OnlyLongestCDNAs_Canis_familiaris.CanFam3.1.cds.all.fa",                       "005_out_vsCanis-familiaris_",            ],
              ["Mustela-putorius-furo_",           "000_OnlyLongestPeps_Mustela_putorius_furo.MusPutFur1.0.pep.all.fa",                         "000_OnlyLongestCDNAs_Mustela_putorius_furo.MusPutFur1.0.cds.all.fa",               "005_out_vsMustela-putorius-furo.txt",    ],
              ["Leptonychotes-weddellii_",         "000_OnlyLongestPeps_out_prot_Leptonychotes-weddellii_rna.gbk.txt",                          "000_OnlyLongestCDNAs_out_nucl_Leptonychotes-weddellii_rna.gbk.txt",                "005_out_vsLeptonychotes-weddellii.txt",        ],
              ["Ailuropoda-melanoleuca_",          "000_OnlyLongestPeps_Ailuropoda_melanoleuca.ailMel1.pep.all.fa",                             "000_OnlyLongestCDNAs_Ailuropoda_melanoleuca.ailMel1.cds.all.fa",                   "005_out_vsAiluropoda-melanoleuca_",      ],
              ["Ursus-maritimus_",                 "000_OnlyLongestPeps_out_prot_Ursus-maritimus_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Ursus-maritimus_rna.gbk.txt",                        "005_out_vsUrsus-maritimus.txt",                ],
              ["Camelus-bactrianus_",              "000_OnlyLongestPeps_out_prot_Camelus-bactrianus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Camelus-bactrianus_rna.gbk.txt",                     "005_out_vsCamelus-bactrianus.txt",             ],
              ["Vicugna-pacos_",                   "000_OnlyLongestPeps_Vicugna_pacos.vicPac1.pep.all.fa",                                      "000_OnlyLongestCDNAs_Vicugna_pacos.vicPac1.cds.all.fa",                            "005_out_vsVicugna-pacos.txt",            ],
              ["Sus-scrofa_",                      "000_OnlyLongestPeps_Sus_scrofa.Sscrofa11.1.pep.all.fa",                                     "000_OnlyLongestCDNAs_Sus_scrofa.Sscrofa11.1.cds.all.fa",                           "005_out_vsSus-scrofa.txt",               ],
              ["Odocoileus-virginianus_",          "000_OnlyLongestPeps_out_prot_Odocoileus-virginianus_rna.gbk.txt",                           "000_OnlyLongestCDNAs_out_nucl_Odocoileus-virginianus_rna.gbk.txt",                 "005_out_vsOdocoileus-virginianus.txt",         ],
              ["Bubalus-bubalis_",                 "000_OnlyLongestPeps_out_prot_Bubalus-bubalis_rna.gbk.txt",                                  "000_OnlyLongestCDNAs_out_nucl_Bubalus-bubalis_rna.gbk.txt",                        "005_out_vsBubalus-bubalis.txt",                ],
              ["Bison-bison_",                     "000_OnlyLongestPeps_out_prot_Bison-bison_rna.gbk.txt",                                      "000_OnlyLongestCDNAs_out_nucl_Bison-bison_rna.gbk.txt",                            "005_out_vsBison-bison.txt",                    ],
              ["Bos-taurus_",                      "000_OnlyLongestPeps_Bos_taurus.UMD3.1.pep.all.fa",                                          "000_OnlyLongestCDNAs_Bos_taurus.UMD3.1.cds.all.fa",                                "005_out_vsBos-taurus.txt",               ],
              ["Ovis-aries_",                      "000_OnlyLongestPeps_Ovis_aries.Oar_v3.1.pep.all.fa",                                        "000_OnlyLongestCDNAs_Ovis_aries.Oar_v3.1.cds.all.fa",                              "005_out_vsOvis-aries.txt",               ],
              ["Capra-hircus_",                    "000_OnlyLongestPeps_Capra_hircus.ARS1.pep.all.fa",                                          "000_OnlyLongestCDNAs_Capra_hircus.ARS1.cds.all.fa",                                "005_out_vsCapra-hircus.txt",             ],
              ["Balaenoptera-acutorostrata_",      "000_OnlyLongestPeps_out_prot_Balaenoptera-acutorostrata_rna.gbk.txt",                       "000_OnlyLongestCDNAs_out_nucl_Balaenoptera-acutorostrata_rna.gbk.txt",             "005_out_vsBalaenoptera-acutorostrata.txt",     ],
              ["Physeter-catodon_",                "000_OnlyLongestPeps_out_prot_Physeter-catodon_rna.gbk.txt",                                 "000_OnlyLongestCDNAs_out_nucl_Physeter-catodon_rna.gbk.txt",                       "005_out_vsPhyseter-catodon.txt",               ],
              ["Lipotes-vexillifer_",              "000_OnlyLongestPeps_out_prot_Lipotes-vexillifer_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Lipotes-vexillifer_rna.gbk.txt",                     "005_out_vsLipotes-vexillifer.txt",             ],
              ["Tursiops-truncatus_",              "000_OnlyLongestPeps_Tursiops_truncatus.turTru1.pep.all.fa",                                 "000_OnlyLongestCDNAs_Tursiops_truncatus.turTru1.cds.all.fa",                       "005_out_vsTursiops-truncatus.txt",       ],
              ["Orcinus-orca_",                    "000_OnlyLongestPeps_out_prot_Orcinus-orca_rna.gbk.txt",                                     "000_OnlyLongestCDNAs_out_nucl_Orcinus-orca_rna.gbk.txt",                           "005_out_vsOrcinus-orca.txt",                   ],

#####Euarchontoglires
              ["Tupaia-belangeri_",                "000_OnlyLongestPeps_Tupaia_belangeri.TREESHREW.pep.all.fa",                                 "000_OnlyLongestCDNAs_Tupaia_belangeri.TREESHREW.cds.all.fa",                       "005_out_vsTupaia-belangeri.txt",                ],
              ["Oryctolagus-cuniculus_",           "000_OnlyLongestPeps_Oryctolagus_cuniculus.OryCun2.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Oryctolagus_cuniculus.OryCun2.0.cds.all.fa",                  "005_out_vsOryctolagus-cuniculus.txt",           ],
              ["Ochotona-princeps_",               "000_OnlyLongestPeps_Ochotona_princeps.OchPri2.0-Ens.pep.all.fa",                            "000_OnlyLongestCDNAs_Ochotona_princeps.OchPri2.0-Ens.cds.all.fa",                  "005_out_vsOchotona-princeps.txt",               ],
              ["Ictidomys-tridecemlineatus_",      "000_OnlyLongestPeps_Ictidomys_tridecemlineatus.SpeTri2.0.pep.all.fa",                       "000_OnlyLongestCDNAs_Ictidomys_tridecemlineatus.SpeTri2.0.cds.all.fa",             "005_out_vsIctidomys-tridecemlineatus.txt",     ],
              ["Fukomys-damarensis_",              "000_OnlyLongestPeps_Fukomys_damarensis.DMR_v1.0.pep.all.fa",                                "000_OnlyLongestCDNAs_Fukomys_damarensis.DMR_v1.0.cds.all.fa",                      "005_out_vsFukomys-damarensis.txt",             ],
              ["Heterocephalus-glaber_",           "000_OnlyLongestPeps_Heterocephalus_glaber_female.HetGla_female_1.0.pep.all.fa",             "000_OnlyLongestCDNAs_Heterocephalus_glaber_female.HetGla_female_1.0.cds.all.fa",   "005_out_vsHeterocephalus-glaber-female.txt",   ],
              ["Octodon-degus_",                   "000_OnlyLongestPeps_Octodon_degus.OctDeg1.0.pep.all.fa",                                    "000_OnlyLongestCDNAs_Octodon_degus.OctDeg1.0.cds.all.fa",                          "005_out_vsOctodon-degus.txt",                  ],
              ["Chinchilla-lanigera_",             "000_OnlyLongestPeps_Chinchilla_lanigera.ChiLan1.0.pep.all.fa",                              "000_OnlyLongestCDNAs_Chinchilla_lanigera.ChiLan1.0.cds.all.fa",                    "005_out_vsChinchilla-lanigera.txt",            ],
              ["Cavia-porcellus_",                 "000_OnlyLongestPeps_Cavia_porcellus.Cavpor3.0.pep.all.fa",                                  "000_OnlyLongestCDNAs_Cavia_porcellus.Cavpor3.0.cds.all.fa",                        "005_out_vsCavia-porcellus.txt",                ],
              ["Cavia-aperea_",                    "000_OnlyLongestPeps_Cavia_aperea.CavAp1.0.pep.all.fa",                                      "000_OnlyLongestCDNAs_Cavia_aperea.CavAp1.0.cds.all.fa",                            "005_out_vsCavia-aperea.txt",                   ],
              ["Dipodomys-ordii_",                 "000_OnlyLongestPeps_Dipodomys_ordii.Dord_2.0.pep.all.fa",                                   "000_OnlyLongestCDNAs_Dipodomys_ordii.Dord_2.0.cds.all.fa",                         "005_out_vsDipodomys-ordii.txt",               ],
              ["Jaculus-jaculus_",                 "000_OnlyLongestPeps_Jaculus_jaculus.JacJac1.0.pep.all.fa",                                  "000_OnlyLongestCDNAs_Jaculus_jaculus.JacJac1.0.cds.all.fa",                        "005_out_vsJaculus-jaculus.txt",               ],
              ["Nannospalax-galili_",              "000_OnlyLongestPeps_Nannospalax_galili.S.galili_v1.0.pep.all.fa",                           "000_OnlyLongestCDNAs_Nannospalax_galili.S.galili_v1.0.cds.all.fa",                 "005_out_vsNannospalax-galili.txt",            ],
              ["Peromyscus-maniculatus_",          "000_OnlyLongestPeps_Peromyscus-maniculatus.Pman_1.0.pep.all.fa",                            "000_OnlyLongestCDNAs_Peromyscus-maniculatus.Pman_1.0.cds.all.fa",                  "005_out_vsPeromyscus-maniculatus.txt",        ],
              ["Cricetulus-griseus_",              "000_OnlyLongestPeps_Cricetulus_griseus_chok1gshd.CHOK1GS_HDv1.pep.all.fa",                  "000_OnlyLongestCDNAs_Cricetulus_griseus_chok1gshd.CHOK1GS_HDv1.cds.all.fa",        "005_out_vsCricetulus-griseus.txt",            ],
              ["Rattus-norvegicus_",               "000_OnlyLongestPeps_Rattus_norvegicus.Rnor_6.0.pep.all.fa",                                 "000_OnlyLongestCDNAs_Rattus_norvegicus.Rnor_6.0.cds.all.fa",                       "005_out_vsRattus-norvegicus.txt",              ],
              ["Mus-pahari_",                      "000_OnlyLongestPeps_Mus_pahari.PAHARI_EIJ_v1.1.pep.all.fa",                                 "000_OnlyLongestCDNAs_Mus_pahari.PAHARI_EIJ_v1.1.cds.all.fa",                       "005_out_vsMus-pahari.txt",                     ],
              ["Mus-spretus_",                     "000_OnlyLongestPeps_Mus_spretus.SPRET_EiJ_v1.pep.all.fa",                                   "000_OnlyLongestCDNAs_Mus_spretus.SPRET_EiJ_v1.cds.all.fa",                         "005_out_vsMus-spretus.txt",                    ],
              ["Mus-musculus_",                    "000_OnlyLongestPeps_Mus_musculus.GRCm38.pep.all.fa",                                        "000_OnlyLongestCDNAs_Mus_musculus.GRCm38.cds.all.fa",                              "005_out_vsMus-musculus.txt",                   ],

              ["Otolemur-garnettii_",              "000_OnlyLongestPeps_Otolemur_garnettii.OtoGar3.pep.all.fa",                                 "000_OnlyLongestCDNAs_Otolemur_garnettii.OtoGar3.cds.all.fa",                       "005_out_vsOtolemur-garnettii.txt",               ],
              ["Microcebus-murinus_",              "000_OnlyLongestPeps_out_prot_Microcebus-murinus_rna.gbk.txt",                               "000_OnlyLongestCDNAs_out_nucl_Microcebus-murinus_rna.gbk.txt",                     "005_out_vsMicrocebus-murinus.txt",               ],
              ["Propithecus-coquereli_",           "000_OnlyLongestPeps_Propithecus_coquereli.Pcoq_1.0.pep.all.fa",                             "000_OnlyLongestCDNAs_Propithecus_coquereli.Pcoq_1.0.cds.all.fa",                   "005_out_vsPropithecus-coquereli.txt",            ],
              ["Carlito-syrichta_",                "000_OnlyLongestPeps_Carlito_syrichta.Tarsius_syrichta-2.0.1.pep.all.fa",                    "000_OnlyLongestCDNAs_Carlito_syrichta.Tarsius_syrichta-2.0.1.cds.all.fa",          "005_out_vsCarlito-syrichta.txt",                 ],
              ["Aotus-nancymaae_",                 "000_OnlyLongestPeps_Aotus_nancymaae.Anan_2.0.pep.all.fa",                                   "000_OnlyLongestCDNAs_Aotus_nancymaae.Anan_2.0.cds.all.fa",                         "005_out_vsAotus-nancymaae.txt",                  ],
              ["Callithrix-jacchus_",              "000_OnlyLongestPeps_Callithrix_jacchus.ASM275486v1.pep.all.fa",                             "000_OnlyLongestCDNAs_Callithrix_jacchus.ASM275486v1.cds.all.fa",                   "005_out_vsCallithrix-jacchus.txt",               ],
              ["Cebus-capucinus_",                 "000_OnlyLongestPeps_Cebus_capucinus.Cebus_imitator-1.0.pep.all.fa",                         "000_OnlyLongestCDNAs_Cebus_capucinus.Cebus_imitator-1.0.cds.all.fa",               "005_out_vsCebus-capucinus-imitator.txt",         ],
              ["Saimiri-boliviensis-boliviensis_", "000_OnlyLongestPeps_Saimiri_boliviensis_boliviensis.SaiBol1.0.pep.all.fa",                  "000_OnlyLongestCDNAs_Saimiri_boliviensis_boliviensis.SaiBol1.0.cds.all.fa",        "005_out_vsSaimiri-boliviensis-boliviensis.txt",  ],
              ["Colobus-angolensis-palliatus_",    "000_OnlyLongestPeps_Colobus_angolensis_palliatus.Cang.pa_1.0.pep.all.fa",                   "000_OnlyLongestCDNAs_Colobus_angolensis_palliatus.Cang.pa_1.0.cds.all.fa",         "005_out_vsColobus-angolensis-palliatus.txt",    ],
              ["Rhinopithecus-roxellana_",         "000_OnlyLongestPeps_Rhinopithecus_roxellana.Rrox_v1.pep.all.fa",                            "000_OnlyLongestCDNAs_Rhinopithecus_roxellana.Rrox_v1.cds.all.fa",                  "005_out_vsRhinopithecus-roxellana.txt",         ],
              ["Rhinopithecus-bieti_",             "000_OnlyLongestPeps_Rhinopithecus_bieti.ASM169854v1.pep.all.fa",                            "000_OnlyLongestCDNAs_Rhinopithecus_bieti.ASM169854v1.cds.all.fa",                  "005_out_vsRhinopithecus-bieti.txt",             ],
              ["Chlorocebus-sabaeus_",             "000_OnlyLongestPeps_Chlorocebus_sabaeus.ChlSab1.1.pep.all.fa",                              "000_OnlyLongestCDNAs_Chlorocebus_sabaeus.ChlSab1.1.cds.all.fa",                    "005_out_vsChlorocebus-sabaeus.txt",             ],
              ["Papio-anubis_",                    "000_OnlyLongestPeps_Papio_anubis.Panu_3.0.pep.all.fa",                                      "000_OnlyLongestCDNAs_Papio_anubis.Panu_3.0.cds.all.fa",                            "005_out_vsPapio-anubis.txt",                    ],
              ["Cercocebus-atys_",                 "000_OnlyLongestPeps_Cercocebus_atys.Caty_1.0.pep.all.fa",                                   "000_OnlyLongestCDNAs_Cercocebus_atys.Caty_1.0.cds.all.fa",                         "005_out_vsCercocebus-atys.txt",                 ],
              ["Mandrillus-leucophaeus_",          "000_OnlyLongestPeps_Mandrillus_leucophaeus.Mleu.le_1.0.pep.all.fa",                         "000_OnlyLongestCDNAs_Mandrillus_leucophaeus.Mleu.le_1.0.cds.all.fa",               "005_out_vsMandrillus-leucophaeus.txt",          ],
              ["Macaca-nemestrina_",               "000_OnlyLongestPeps_Macaca_nemestrina.Mnem_1.0.pep.all.fa",                                 "000_OnlyLongestCDNAs_Macaca_nemestrina.Mnem_1.0.cds.all.fa",                       "005_out_vsMacaca-nemestrina.txt",               ],
              ["Macaca-fascicularis_",             "000_OnlyLongestPeps_Macaca_fascicularis.Macaca_fascicularis_5.0.pep.all.fa",                "000_OnlyLongestCDNAs_Macaca_fascicularis.Macaca_fascicularis_5.0.cds.all.fa",      "005_out_vsMacaca-fascicularis.txt",             ],
              ["Macaca-mulatta_",                  "000_OnlyLongestPeps_Macaca_mulatta.Mmul_8.0.1.pep.all.fa",                                  "000_OnlyLongestCDNAs_Macaca_mulatta.Mmul_8.0.1.cds.all.fa",                        "005_out_vsMacaca-mulatta.txt",                  ],

              ["Nomascus-leucogenys_",             "000_OnlyLongestPeps_Nomascus_leucogenys.Nleu_3.0.pep.all.fa",                               "000_OnlyLongestCDNAs_Nomascus_leucogenys.Nleu_3.0.cds.all.fa",                     "005_out_vsNomascus-leucogenys.txt",              ],
              ["Pongo-abelii_",                    "000_OnlyLongestPeps_Pongo_abelii.PPYG2.pep.all.fa",                                         "000_OnlyLongestCDNAs_Pongo_abelii.PPYG2.cds.all.fa",                               "005_out_vsPongo-abelii.txt",                     ],
              ["Gorilla-gorilla_",                 "000_OnlyLongestPeps_Gorilla_gorilla.gorGor4.pep.all.fa",                                    "000_OnlyLongestCDNAs_Gorilla_gorilla.gorGor4.cds.all.fa",                          "005_out_vsGorilla-gorilla-gorilla.txt",          ],
              ["Pan-troglodytes_",                 "000_OnlyLongestPeps_Pan_troglodytes.Pan_tro_3.0.pep.all.fa",                                "000_OnlyLongestCDNAs_Pan_troglodytes.Pan_tro_3.0.cds.all.fa",                      "005_out_vsPan-troglodytes.txt",                  ],
              ["Pan-paniscus_",                    "000_OnlyLongestPeps_Pan_paniscus.panpan1.1.pep.all.fa",                                     "000_OnlyLongestCDNAs_Pan_paniscus.panpan1.1.cds.all.fa",                           "005_out_vsPan-paniscus.txt",                     ],
             #["Homo-sapiens_",                    "000_OnlyLongestPeps_Homo-sapiens_prot1.gbk.txt",                                            "000_OnlyLongestCDNAs_Homo-sapiens_rna1.gbk.txt",                                   "005_out_vsHomo-sapiens.txt",                     ],
              ["Homo-sapiens_",                    "000_OnlyLongestPeps_Homo_sapiens.GRCh38.pep.all.fa",                                        "000_OnlyLongestCDNAs_Homo_sapiens.GRCh38.cds.all.fa",                              "005_out_vsHomo-sapiens.txt",                     ],


#######
]

geneticCode = {
           #"((U|T|C|Y|A)(U|T)G)"               : "B",
           #"((C(U|T).)|((U|T)(U|T)(A|G|R)))"   : "L",
            "CTA"                             : "L",
            "CTT"                             : "L",
            "CTG"                             : "L",
            "CTC"                             : "L",
            "TTA"                             : "L",
            "TTG"                             : "L",
            "TTR"                             : "L",
           # "((CG.)|(AG(A|G|R)))"               : "R",
            "CGA"                             : "R",
            "CGT"                             : "R",
            "CGG"                             : "R",
            "CGC"                             : "R",
            "AGA"                             : "R",
            "AGG"                             : "R",
            "AGR"                             : "R",
           # "(((U|T)C.)|(AG(U|T|C|Y)))"         : "S",
            "TCA"                             : "S",
            "TCT"                             : "S",
            "TCG"                             : "S",
            "TCC"                             : "S",
            "AGT"                             : "S",
            "AGC"                             : "S",
            "AGY"                             : "S",
           # "(GC.)"                             : "A",
            "GCA"                             : "A",
            "GCT"                             : "A",
            "GCG"                             : "A",
            "GCC"                             : "A",
           # "(GG.)"                             : "G",
            "GGT"                             : "G",
            "GGC"                             : "G",
            "GGA"                             : "G",
            "GGG"                             : "G",
           # "(CC.)"                             : "P",
            "CCT"                             : "P",
            "CCC"                             : "P",
            "CCA"                             : "P",
            "CCG"                             : "P",
           # "(AC.)"                             : "T",
            "ACT"                             : "T",
            "ACC"                             : "T",
            "ACA"                             : "T",
            "ACG"                             : "T",
           # "(G(U|T).)"                         : "V",
            "GTT"                             : "V",
            "GTC"                             : "V",
            "GTA"                             : "V",
            "GTG"                             : "V",
           # "(A(U|T)(U|T|C|Y|A))"               : "I",
            "ATT"                             : "I",
            "ATC"                             : "I",
            "ATA"                             : "I",
           # "(((U|T)A(A|G|R))|((T|U)GA))"    : "_",
            "TAA"                             : "X",  #* Ter
            "TAG"                             : "X",  #* Ter
            "TAR"                             : "X",  #* Ter
            "TGA"                             : "X",  #* Ter
           # "((U|T)G(U|T|C|Y))"                 : "C",
            "TGT"                             : "C",  #Cys  
            "TGC"                             : "C",  #Cys  
            "TGY"                             : "C",  #Cys  
           # "(GA(U|T|C|Y))"                     : "D",
            "GAT"                             : "D",  #Asp
            "GAC"                             : "D",  #Asp
            "GAY"                             : "D",  #Asp
           # "(GA(A|G|R))"                       : "E",
            "GAA"                             : "E",  #Glu
            "GAG"                             : "E",  #Glu
            "GAR"                             : "E",  #Glu
           # "((U|T)(U|T)(U|T|C|Y))"             : "F",
            "TTT"                             : "F",  #Phe
            "TTC"                             : "F",  #Phe
            "TTY"                             : "F",  #Phe
           # "(CA(U|T|C|Y))"                     : "H",
            "CAT"                             : "H",  #His
            "CAC"                             : "H",  #His
            "CAY"                             : "H",  #His
           # "(AA(A|G|R))"                       : "K",
            "AAA"                             : "K",  #Lys
            "AAG"                             : "K",  #Lys
            "AAR"                             : "K",  #Lys
           # "(AA(U|T|C|Y))"                     : "N",
            "AAT"                             : "N",  #Asn
            "AAC"                             : "N",  #Asn
            "AAY"                             : "N",  #Asn
           # "(CA(A|G|R))"                       : "Q",
            "CAA"                             : "Q",  #Gln
            "CAG"                             : "Q",  #Gln
            "CAR"                             : "Q",  #Gln
           # "((U|T)A(U|T|C|Y))"                 : "Y",
            "TAT"                             : "Y",  #Tyr
            "TAC"                             : "Y",  #Tyr
            "TAY"                             : "Y",  #Tyr
           # "(A(U|T)G)"                         : "M",
            "ATG"                             : "M",  #Met
           # "((U|T)GG)"                         : "W",
            "TGG"                             : "W",  #Trp  
           # "..."                               : "X",
           # "(NNN)"                             : "X",
            "NNN"                             : "X",  
           # "(N(.|N).)"                         : "X",
            "N.."                             : "X",  
            "NN."                             : "X",  
           # "(.(.|N)N)"                         : "X",
            ".NN"                             : "X",  
            "..N"                             : "X",  
           # "(.N.)"                             : "X",
            ".N."                             : "X",  
            "---"                             : "-"}
### Codes follow pal2nal.



resHTMLlines = '''
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
    <head>
        <meta http-equiv="content-type" content="text/html;charset=shift_jis">
        <title>TITLE</title>
        <link href="main.css" rel="stylesheet" type="text/css" media="all">
    </head>


<body bgcolor="#eeeeee" leftmargin="20" marginheight="20" marginwidth="20" topmargin="20">
<table align="center" border="0" cellspacing="5" cellpadding="5" bgcolor="white">

  <!-- title -->
  <tr><td width="600"><table width="100%" border="0" cellspacing="2" cellpadding="0" bgcolor="#000088" height="50">
     <tr>
       <td align="center" valign="middle">
         <font size="5" color=#FFFFFF face="Verdana, Arial, Helvetica, sans-serif"><b>TITLE</b></font>
       </td>
     </tr>
  </table></td></tr>

  <!-- Contents -->
  <tr><td><table border="0" cellpadding="0" cellspacing="0">

    <tr>
      <td align="left"  valign="top" width="10%">First query:</td>
      <td align="left"  valign="top" width="75%">FIRSTQUERY</td>
      <td align="right" valign="top" width="15%"><!-- NEXTPAGE --></td>
    </tr>

    <tr>
      <td align="left" valign="top">Result:</td>
      <td align="left" valign="top">RESULTMESSAGE</td>
      <td align="right" valign="top"><!-- PREVIOUSPAGE --></td>
    </tr>

    <tr><td colspan="3" align="center" valign="top"><Hr></td></tr>
    <tr><td colspan="3" align="left"   valign="top" name="REARRANGED1">REARRANGED_TREE</td></tr>
    <tr><td colspan="3" align="center" valign="top" name="REARRANGED2">Rearranged gene tree</td></tr>
    <tr><td colspan="3" align="center" valign="top" name="REARRANGED3"><Hr></td></tr>
    <tr><td colspan="3" align="center" valign="top" name="REARRANGED4">&#8593;</td></tr>
    <tr><td colspan="3" align="center" valign="top" name="REARRANGED5"><Hr></td></tr>
    <tr><td colspan="3" align="left" valign="top"><img src="115_1stGeneTree.png"></td></tr>
    <tr><td colspan="3" align="center" valign="top">NJ tree</td></tr>

    </table></td></tr>

    <tr><td><table width="100%" border="0" cellspacing="2" cellpadding="0">
      <tr>
        <td colspan="3"><hr></td>
      </tr>
      <tr>
        <td width="20%">&nbsp;</td>
        <td align="center" width="40%"><a href="http://www.geocities.jp/ancientfishtree/index_eng.html" target="_blank"><em>jun.inoueAToist.jp</em></a></td>
        <td width="20%"><div align="right"> <a href="link"></a></div></td>
      </tr>
    </table></td></tr> 

</table>

</body>

</html>
'''

resHTMLlines_error = '''
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
    <head>
        <meta http-equiv="content-type" content="text/html;charset=shift_jis">
        <title>TITLE</title>
        <link href="main.css" rel="stylesheet" type="text/css" media="all">
    </head>


<body bgcolor="#eeeeee" leftmargin="20" marginheight="20" marginwidth="20" topmargin="20">
<table align="center" border="0" cellspacing="5" cellpadding="5" bgcolor="white">

  <!-- title -->
  <tr><td width="600"><table width="100%" border="0" cellspacing="2" cellpadding="0" bgcolor="#000088" height="50">
     <tr>
       <td align="center" valign="middle">
         <font size="5" color=#FFFFFF face="Verdana, Arial, Helvetica, sans-serif"><b>TITLE</b></font>
       </td>
     </tr>
  </table></td></tr>

  <!-- Contents -->
  <tr><td><table width="100%" border="0" cellpadding="0" cellspacing="0">

    <tr>
      <td align="left"  valign="top" width="15%">First query:</td>
      <td align="left"  valign="top" width="70%">FIRSTQUERY</td>
      <td align="right" valign="top" width="15%"><!-- NEXTPAGE --></td>
    </tr>

    <tr>
      <td align="left" valign="top">Result:</td>
      <td align="left" valign="top">RESULTMESSAGE</td>
      <td align="right" valign="top"><!-- PREVIOUSPAGE --></td>
    </tr>

    </table></td></tr>

    <tr><td><table width="100%" border="0" cellspacing="2" cellpadding="0">
      <tr>
        <td colspan="3"><hr></td>
      </tr>
      <tr>
        <td width="20%">&nbsp;</td>
        <td align="center" width="40%"><a href="http://www.geocities.jp/ancientfishtree/index_eng.html" target="_blank"><em>jun.inoueAToist.jp</em></a></td>
        <td width="20%"><div align="right"> <a href="link"></a></div></td>
      </tr>
    </table></td></tr> 

</table>

</body>

</html>
'''

### File uploading Start
#def FileExtensionGetAllowUpload(allow_ext_seq):
#    allow_ext_seq = ["txt", "fas", "fa"]
#    for v in allow_ext:
#        if (v == ext):
#            return True
#    return False

def StringGetFileExtension(string):
    string = re.split("\\\/", string)[-1]
    a      = re.split("\.", string)
    if (len(a) > 1):
        return a[-1]
    else:
        return None

def FileExtensionGetAllowUpload(allow_ext1, ext):
    for v in allow_ext1:
        if (v == ext):
            return True
    else:
        False

def uploadedFileSave(query):

    if not (query.has_key("input_file")):
        print ("Error: Select sequence file.")
        exit()
    
    input_file = query['input_file']

    if not (input_file.file):
        print("Error: Uploaded file does not contain TempraryFile object.")
        exit()

    file_ext = StringGetFileExtension(input_file.filename)
    allow_ext_seqFile = ["txt"]
    if not (FileExtensionGetAllowUpload(allow_ext_seqFile, file_ext)):
        print('Error: Check your seqeunce file. The extension should be ".txt".')
        exit()

    querySeqChr       = query.getvalue("querySeqChr")
    blastEvalue       = query.getvalue("blastEvalue")
    blastTopHits      = query.getvalue("blastTopHits")
    nonGapSiteRate    = float(query.getvalue("nonGapSiteRate"))
    dataset           = query.getvalue("dataset")
    if querySeqChr == "prot":
        dataset = "Amino_acid"
    RearrangementBSthreshold = query.getvalue("RearrangementBSthreshold")
    taxonSamplingList = query.getlist("taxon_checkbox")
    analysisGroupName = query.getvalue("analysisGroupName")
    reconciliation    = query.getvalue("reconciliation")
    
    input_treeFile = ""
    if reconciliation == "treeSearchRearrange":
        if not (query.has_key("input_treeFile")):
            print ("Please upload your species tree file.")
            exit()
        input_treeFile = query['input_treeFile']
        file_ext = StringGetFileExtension(input_treeFile.filename)
        allow_ext_treeFile = ["tre"]
        if not (FileExtensionGetAllowUpload(allow_ext_treeFile, file_ext)):
            print('Extension of tree file should be ".tre"')
            exit()

    #eachDirAddress = dirAddress + "yuraiWork/" + str(countFileName) + "/"
    if not os.path.exists(eachDirAddress):
        os.mkdir(eachDirAddress)
    fh = file(eachDirAddress + "000_uploaded.txt", "w")
    fh.write(input_file.file.read())
    fh.close()

    if reconciliation == "treeSearchRearrange":
        fhtree = file(eachDirAddress + "000_uploadedTree.txt", "w")
        fhtree.write(input_treeFile.file.read())
        fhtree.close()

    return eachDirAddress, taxonSamplingList, querySeqChr, blastEvalue, blastTopHits, nonGapSiteRate, dataset, RearrangementBSthreshold, analysisGroupName, reconciliation


def dirFileMake(infileName_seqFN, infileName_treeFN):

    ps = open(infileName_seqFN)
    seqLines = list(ps)
    ps.close()

    if not os.path.exists(outdir):
        os.mkdir(outdir)

    if not os.path.exists(eachDirAddress):
        os.mkdir(eachDirAddress)

    fs = open(eachDirAddress + "000_uploaded.txt", "w")
    for line in seqLines:
        fs.write(line)
    fs.close()

    pt = open(infileName_treeFN)
    treeLines = list(pt)
    pt.close()
    if reconciliation == "treeSearchRearrange":
        fhtree = open(eachDirAddress + "000_uploadedTree.txt", "w")
        for line in treeLines:
            fhtree.write(line)
        fhtree.write("\n")
        fhtree.close()

def dbLinesMake():
    dbLinesFN = []
    #for dbLine in dbLinesTMP:
    #    spName = dbLine[0]
    #    if spName in taxonSamplingList:
    #        print spName, "<br>"
    #        dbLinesFN.append(dbLine)
    for spName in taxonSamplingList:
        for dbLine in dbLinesTMP:
            if spName == dbLine[0]:
                dbLinesFN.append(dbLine)
    #for dbLine in dbLinesFN:
    #    print dbLine[0], "<br>"
    #exit()
    return dbLinesFN
### File uploading End



### cDNA and AA file make Start
def checkUplodedFileAsFastaForamt():
    f = open(eachDirAddress + "000_uploaded.txt")
    lines = list(f)
    f.close()
    if not lines:
        print('Error: Cannot find your sequence file in the specified directory.\n')
        exit()
    if not lines[0].startswith(">"):
        print('Error: Check your sequence file. In fasta format, name line starts with ">"\n')
        exit()
    recs_uploaded = readFasta_dict(eachDirAddress, "000_uploaded.txt")
    for name, seq in recs_uploaded.items():
        if re.search("[,\/:\\\]", name):
            print ('Error: Check your name in seq file. Sequence line should not contain "," and "/".', "<br>")
            print (name, "<br>")
            exit()
        if querySeqChr == "prot":
            #counter = Counter(seq)
            #print len(seq)/2
            #print (counter['A'] + counter['T'] + counter['G'] + counter['C'])
            #print "<br>"
            if len(seq)/2 < (seq.count('A') + seq.count('T') + seq.count('G') + seq.count('C')):
                print ('Error: Check your sequence. Amino acid sequence?.', "<br>")
                print ("in ", name, "<br>")
                exit()
        else:
            if re.search("[^ATGCNX ]", seq):
                print ('Error: Check your sequence. Sequences should be consist of A,T,G,C,N,X.', "<br>")
                print ("in ", name, "<br>")
                exit()

def ckeck_cDNAsequence(recsFN):
    for name, seq in recsFN.items():
        if re.search("[^ATGCNXatgcnx ]", seq):
            print ("Error: Please check sequence in: ", name, "<br>")
            print ("The sequence should be A,T,G,C,N,X. Analysis stopped.")
            exit()

def cDNAqueryFileMaker():

    recs_uploaded = readFasta_dict(eachDirAddress, "000_uploaded.txt")
    ckeck_cDNAsequence(recs_uploaded)
    f = open(eachDirAddress + "000_cDNAQuery.txt", "w")

    count = 1;
    for name, seq in recs_uploaded.items():
        name = name.rstrip("\n")
        name = name.rstrip("\r")
        if reconciliation == "treeSearchRearrange":

            match = re.search(r"^>([^_]+)_", name)
            if match:
                speciesNamePrefix = match.group(1)
                name2 = re.sub("_.*$", "", name)
                name3 = re.sub("^[^_]+_", "", name)
                newName = name2 + "_NUM" + str(count) + "_" + name3
                newName = re.sub("-{2,}", "-", newName)
                newName = re.sub("\|", "", newName)
                #newName = re.sub("(.{60}).*", r"\1", newName)
                f.write(newName + "\n")
            else:
                print("Error: Check the name line,", name, "\n")
                exit()
        else:
            newName = str(count) + "_" + name[1:]
            newName = re.sub("[,\/ ]", "-", newName)
            newName = re.sub("-{2,}", "-", newName)
            newName = re.sub("\|", "", newName)
            newName = re.sub("-_", "_", newName)
            newName = re.sub("_-", "_", newName)
            #newName = re.sub("(.{60}).*", r"\1", newName)
            newName = ">" + newName
            f.write(newName + "\n")

        f.write(seq + "\n")
        count += 1
    f.close()


def readPhy_dict(phyFileName):
    phyFile = open(eachDirAddress + phyFileName, "r")
    lines = list(phyFile)
    seqDictFN  = OrderedDict()
    for line in lines[1:]:
        name,seq = re.split(" +", line)
        seq = seq.rstrip("\n")
        seqDictFN[">" + name] = seq
    phyFile.close()
    return seqDictFN

def readFasta_dict(dirAddressFN, InfileNameFN):
    Infile = open(dirAddressFN + InfileNameFN, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if not Line:
            continue
        elif Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            Line = Line.replace("\n", "")
            Line = Line.replace("\r", "")
            #if InfileNameFN == "000_uploaded.txt":
            #    Line = re.sub("-", "", Line)
            seqDictFN[Name] += Line.upper()
    Infile.close()
    return seqDictFN
    
def splitDna(dna):
    codons = []
    for start in range(0, len(dna)-2, 3):
        codons.append(dna[start:start+3])
    return(codons)

def translation(dna):
    dna = dna.upper()
    protein = ""
    for codon in splitDna(dna):
        #aa = ""
        #selectedAA = []
        #for key in geneticCode:
        #    if re.match(key, codon):
        #        selectedAA.append(geneticCode.get(key))
        ## B or M
        #if len(selectedAA) > 1:
        #    aa = selectedAA[1]
        #else:
        #    aa = selectedAA[0]
        
        aa = geneticCode.get(codon, "X")

        protein = protein + aa
    return protein

def aaSeqMaker():
    if querySeqChr == "nucl":
        recfn = readFasta_dict(eachDirAddress, "000_cDNAQuery.txt")
    else:
        recfn = readFasta_dict(eachDirAddress, "000_uploaded.txt")

    fa = open(eachDirAddress + "000_aaQuery.txt","w")

    # >Human_ENSP00000259365 gene:ENSG00000136842 transcript:ENST00000259365 gene_biotype:protein_coding
    for name, seq in recfn.items():
        newName = re.sub("\|", "", name)
        fa.write(newName + "\n")
        #fa.write(">Sequence_" + name + "_NONE gene:" + name + " transcript:" + name + " gene_biotype:protein_coding\n")
        #name = re.sub(">(Query\d+) .*$", "\\1", name)
        if querySeqChr == "nucl":
            fa.write(translation(seq) + "\n")
        else:
            fa.write(seq + "\n")
    fa.close()
### cDNA and AA file make End

### Tree file

def get_nodeNames_ancestral():
    nodeNames_ancestral = ""
    if analysisGroupName == "Protostomia" or analysisGroupName == "Deuterostomia": 
        nodeNames_ancestral = ["Bilateria"]
#        nodeNames_ancestral = ["Bilateria", "CnidariaHomo", "TrichoplaxHomo", "AmphimedonHomo", "Metazoa"]
    elif analysisGroupName == "Vertebrata":
        #nodeNames_ancestral = ["Olfactore", "Chordata", "Deuterostomia", "Bilateria"]
        nodeNames_ancestral = ["Olfactore", "Chordata"]
    else:
        nodeNames_ancestral = ["Teleostomi"]
        nodeNames_ancestral = ["Teleostomi", "Gnathostomata", "Vertebrata"]
        #nodeNames_ancestral = ["Teleostomi", "Gnathostomata", "Vertebrata", "Olfactore", "Chordata"]
    return nodeNames_ancestral

def leafCollectInOrderFrom_bothNHXnewick (treeFileName):
    treeTMP = open(eachDirAddress + treeFileName, "r")
    tree = list(treeTMP)[0]
    treeTMP.close()
    leaves = tree.split(",")
    leaves = [re.sub("^\(*([^:\(\)]+).*$", r"\1", leaf) for leaf in leaves]
    leaves = [re.sub("[\t\n]", "", leaf) for leaf in leaves]
    #for leaf in leaves:
    #    print(leaf, "<br>")
    #exit()
    return leaves

def TEST_querySpIsInTree():
    recsUploadedCDNA = readFasta_dict(eachDirAddress, "000_uploaded.txt")
    speciesNamePrefixes = []
    
    for name, seq in recsUploadedCDNA.items():
        match = re.search(r"^>([^_ ]+)_", name)
        if not match:
            print ("Error: Sequence name should be start from >Xxxx-xxxx_.")
            exit()

    for name, seq in recsUploadedCDNA.items():
        match = re.search(r"^>([^_ ]+)_", name)
        if match:
            speciesNamePrefixes.append(match.group(1))

    if not speciesNamePrefixes:
        print ("Error: Sequence name should be start from >Xxxx-xxxx_.")
        exit()

    spTreeTMP = open(eachDirAddress + "000_uploadedTree.txt")
    spTree = list(spTreeTMP)[0]
    spTreeTMP.close()
    if re.search("\)\)", spTree) or re.search("\),", spTree) :
        print ("Error: In the species tree, all nodes should have node name. <br>")
        print ("Please check you newick format using FigTree or TreeGraph_2. <br>")
        exit()
    num_rightOpen = spTree.count("(")
    num_leftOpen  = spTree.count(")")
    num_comma     = spTree.count(",")
    if num_rightOpen != num_leftOpen:
        print ("Error: In the species tree, numbers of right and left parehtheses should be same. <br>")
        exit()
    if num_rightOpen != num_comma or num_leftOpen != num_comma :
        print ("Error: In the species tree, all nodes should be bufuricated. <br>")
        exit()

    allNodes  = nodesCollectFromNewick(eachDirAddress, treeFileName = "000_uploadedTree.txt")

    orthoGroupSpNames = ""
    #nodeNames_ancestral = ["Teleosto"]
    for nodeName_ancestral in nodeNames_ancestral:
        for node in allNodes:
            if nodeName_ancestral == node[2]:
                orthoGroupSpNames = node[1]
    if not orthoGroupSpNames:
        print ("Error: Orthogroup node, ", nodeNames_ancestral, " is not found in species tree.")
        exit()

    if not speciesNamePrefixes[0] in orthoGroupSpNames:
        print ("Error: Species name of first query, ", speciesNamePrefixes[0], ", is not found in ", nodeNames_ancestral, " clade of species tree.")
        exit()

    allLeaves = allNodes[0][1]
    for speciesNamePrefix in speciesNamePrefixes:
        if not speciesNamePrefix in allLeaves:
            print ("Error: Sequence, ", speciesNamePrefix, ", is not found in the uploaded species tree.")
            exit()
    for dbLine in dbLines:
        spName_dbLine = dbLine[0]
        spName_dbLine = re.sub("_$","",spName_dbLine)
        if not spName_dbLine in allLeaves:
            print ("Error: Species tree, ", spName_dbLine, ", is not found in the uploaded species tree.")
            exit()
    return allNodes


def nodesCollectFromNewick(eachDirAddress, treeFileName):

    t = open(eachDirAddress + treeFileName)
    treeFN = "".join(list(t))
    treeFN = re.sub("[ \n]", "", treeFN)
    t.close()
    
    nodes = []     # 2D array for nodes
    cladeReg = "\(([^\(\)]+)\)([\d\w]+)"
    while re.search(cladeReg, treeFN):
        treeFN = treeFN.rstrip("\n")
        match = re.search(cladeReg, treeFN)               # Pick up the smallest and leftmost clade for the following analysis
        leavesString = match.group(1)
        exp          = match.group(2)
        leaves = set(leavesString.split(","))
        leaves = [re.sub(":.+", "", leaf) for leaf in leaves]  # Delete branch lengths
        leaves = [re.sub(" ", "", leaf) for leaf in leaves]  # Delete space
        treeFN = re.sub(cladeReg, r"\1", treeFN, 1)            # Delete the outer parentheses from the analyzed clade
        nodes.append([len(leaves), leaves, exp])

    sortedNodes = sorted(nodes, key=lambda x:x[0], reverse=True)

    # Add leaves as nodes
    largestNode = sortedNodes[0]
    for leaf in largestNode[1]:
        #tempLeafNode = {leaf}
        #tempLeafNode = set(leaf)
        tempLeafNode = [leaf]
        sortedNodes.append([1, tempLeafNode, leaf])

    return sortedNodes


def nhx2NewickWithNHXnodeName(tree):
  
    cladeReg = "\)([^\[]+\[&&NHX[^\]]+\])"
    count = 0
    while re.search(cladeReg, tree):
        #print("count   :", count)
        matchA = re.search(cladeReg, tree)
        expTemp  = matchA.group(1);
        #print("expTemp:", expTemp)
        #if count == 10:
        #    exit()

        matchB = re.search("(\[.*\])", expTemp)
        exp  = matchB.group(1)
 
        if re.search("B=([\d]+)", expTemp):
            matchC = re.search("B=([\d]+)", expTemp)
            bs = matchC.group(1)
        else:
            bs = "r"

        exp = re.sub("&&NHX:", "", exp)
        exp = re.sub(":",      "_", exp)
        exp = re.sub("_B=.*$", "", exp)
        
        #print("expTemp :", expTemp)
        #print("bs      :", bs)
        #print("exp     :", exp)
        #print("bs + exp:", bs + exp)

        tree = re.sub(cladeReg, ")" + bs + "_" + exp, tree, 1)
        count += 1
        #print("tree2: ", tree)
        #print()
    
    tree = re.sub("\:[\d|\.E-]+", "", tree)   #Delete the branch lengths

    ## left node name
    tree = re.sub("\[&&NHX:[^]]+\]", "",  tree)
    tree = re.sub("[\[\]]",          "", tree)
    #tree = re.sub("\]",              "",  tree)

    return tree;
### 


### Ortholog select Start
def cladesCollectFromNewick(treeFN):
    clades = []     # 2D array for clades
    cladeReg = "\(([^\(\)]+)\)(\w+)"
    while re.search(cladeReg, treeFN):
        treeFN       = treeFN.rstrip("\n")
        match        = re.search(cladeReg, treeFN)                # Pick up the smallest and leftmost clade for the following analysis
        leavesString = match.group(1)
        exp          = match.group(2)
        leaves       = set(leavesString.split(","))
        treeFN       = re.sub(cladeReg, r"\1", treeFN, 1)      # Delete the outer parentheses from the analyzed clade
        clades.append([len(leaves), leaves, exp])

    sortedClades     = sorted(clades, key=lambda x:x[0], reverse=True)

    ## Add leaf as a clade
    largestClade = sortedClades[0];
    for leaf in largestClade[1]:
        exp           = leaf
        tempLeafClade = set([leaf])
        sortedClades.append([1, tempLeafClade, exp])

    return sortedClades


def cladesCollectFromNHX(treeFN):

    clades = []     # 2D array for clades
    expReg = "\[.*?\]"
    cladeReg = "\(([^\(\)]+)\)(.*?\[.*?\])"
    while re.search(cladeReg, treeFN):
        treeFN       = treeFN.rstrip("\n")
        match        = re.search(cladeReg, treeFN)                # Pick up the smallest and leftmost clade for the following analysis
        leavesString = match.group(1)
        exp          = match.group(2)
        leavesString = re.sub("\[.*?\]",        "",    leavesString)   # Delete exp [...] of internal branches
        leavesString = re.sub(":\d+\.\d+E-\d*", "",    leavesString)   # Delete blanch lengths with E-
        leavesString = re.sub(":\d+\.\d+",      "",    leavesString)   # Delete blanch lengths of internal branches
        leaves       = set(leavesString.split(","))
        treeFN       = re.sub(cladeReg,    r"\1", treeFN, 1)      # Delete the outer parentheses from the analyzed clade
        clades.append([len(leaves), leaves, exp])

    sortedClades     = sorted(clades, key=lambda x:x[0], reverse=True)

    ## Add leaf as a clade
    largestClade = sortedClades[0];
    for leaf in largestClade[1]:
        #print ("leaf:", leaf)
        match         = re.search(r"([^_]+)_", leaf)
        exp           = "[&&NHX:S=" + match.group(1) +"]"
        tempLeafClade = set([leaf])
        sortedClades.append([1, tempLeafClade, exp])

    return sortedClades


def orthoGroupIdentifyFromNHX (treeNHX):

    #f1stTree = open(eachDirAddress + f1stTree)
    #treeNHX = list(f1stTree)[0]
    #f1stTree.close()

    f1stTree = open(eachDirAddress + "000_uploadedTree.txt")
    speciesTree = "".join(list(f1stTree))
    speciesTree = re.sub("[ \n]", "", speciesTree)
    f1stTree.close()

    topHits = topHitPicker()
    #for name, value in topHits.items():
    #    print name, "<br>"
    #    print value, "<br>"
    #exit()

    topHitName_1stQuery = list(topHits.values())[0][0]
    topHitName_1stQueryUploaded = list(topHits.keys())[0]
    
    #print("topHitName_1stQuery:", topHitName_1stQuery)
    #print("topHitName_1stQueryUploaded:", topHitName_1stQueryUploaded)
    #exit()

    allCladesSR   = cladesCollectFromNHX(treeNHX)


    keyClades   = []
    #print("cladeNamesSR", cladeNamesSR, "<br>")
    for clade in allCladesSR:
        #print "clade[1]:", clade[1], "<br>"
        #for leaf in clade[1]:
        #    print leaf
        #exit()
        for nodeName_ancestral in nodeNames_ancestral:
            #print("nodeName_ancestral:", nodeName_ancestral)
            if re.search("S=" + nodeName_ancestral + ":", clade[2]):
                #print("  FOUND")
                if [leaf for leaf in clade[1] if re.search(topHitName_1stQuery[1:], leaf)]:
                    keyClades.append(clade)
            #print("<br><br>")
    orthoGroupSR = []
    if not keyClades:
        if re.search("NoBlastHit", topHitName_1stQuery):
            stringTMP = "No blast hit was found for your 1st query within genome of this species."
        else:
            stringTMP = "No orthogroup was found for :" + topHitName_1stQueryUploaded + "<br> in the rearranged tree. "
            if analysisGroupName == "Protostomia":
                stringTMP += "Include deuterostomes.<br>"
            elif analysisGroupName == "Deuterostomia":
                stringTMP += "Include protostomes.<br>"
            elif analysisGroupName == "Vertebrata":
                stringTMP += "Include non-vertebrate chordates.<br>"
            else:
                stringTMP += "Include tetrapods.<br>"
        orthoGroupSR = [0, 0, stringTMP]
        orthogroupNodeInfor = ""
    else:
        orthoGroupSR = keyClades.pop()
        #print("orthoGroupSR", orthoGroupSR)
    return orthoGroupSR

def isIndependent(checkCladeLeave, focalCladeLeave):
    for ckeckCladeLeaf in checkCladeLeave:
        if [focalCladeLeaf for focalCladeLeaf in focalCladeLeave if re.search(ckeckCladeLeaf, focalCladeLeaf)]:
            return 0;
    return 1;

def childCladesCollect(allCladesSR, orthoGroupSR):
    childCladesSR = []
    for eachClade in allCladesSR:
        if eachClade[1].issubset(orthoGroupSR[1]):
            childCladesSR.append(eachClade)
    return childCladesSR;

def sisterCladeIdentify(childCladesSR, daughterGroup1stSR):
    daughterGroup2ndSR = ""
    for eachChildClade in childCladesSR:
        if isIndependent(eachChildClade[1], daughterGroup1stSR[1]):
            daughterGroup2ndSR = eachChildClade;
            break
    return daughterGroup2ndSR


def daughterGroupsIdentify(allCladesSR, orthoGroupSR):
    childClades      = childCladesCollect(allCladesSR, orthoGroupSR)
    daughterGroup1st = childClades[1];
    daughterGroup2nd = sisterCladeIdentify(childClades, daughterGroup1st)
    return(daughterGroup1st, daughterGroup2nd)


def selectOrthogroupsFromNewick(treeNewick, cladeNamesSR, topHitName_1stQuery):
    keyClades   = []
    allCladesSR  = cladesCollectFromNewick (treeNewick)
    #print("cladeNamesSR", cladeNamesSR, "<br>")
    for clade in allCladesSR:
        #print "clade[2]:", clade[2], "<br>"
        for cladeNameSR in cladeNamesSR:
            if clade[2] == cladeNameSR:
                if [leaf for leaf in clade[1] if re.search(topHitName_1stQuery, leaf)]:
                    keyClades.append(clade)
    if not keyClades:
        print ("Error: Stopped in species tree (Newick). No orthoGroup was found for ", cladeNamesSR, topHitName_1stQuery)
        exit()
    else:
        orthoGroupSR = keyClades.pop()
        return orthoGroupSR


### Ortholog select End


### makeSummary Start
def make_cladeSpNamePrefixes(speciesTree, nodeNames, topHitName_1stQuery):
    spNamePrefixesInClade = []
    spNamePrefix_topHitName_1stQuery = re.sub("^>([^_]+)_.*$", r"\1", topHitName_1stQuery)
    spNamePrefixes_clade2D = selectOrthogroupsFromNewick(speciesTree, nodeNames, spNamePrefix_topHitName_1stQuery)
    spNamePrefixesTMP      = spNamePrefixes_clade2D[1]
    for dbLine in dbLines:
        if dbLine[0][:-1] in spNamePrefixesTMP:
            spNamePrefixesInClade.append(dbLine[0][:-1])
    return spNamePrefixesInClade

def leafCountFromSpNamePrefix(orthoGroup, spNamePrefixes):
    rec_orthoNums = OrderedDict()
    for spNamePrefix in spNamePrefixes:
        hits = len([orthoLeaf for orthoLeaf in orthoGroup[1] if re.search(spNamePrefix, orthoLeaf)])
        rec_orthoNums[spNamePrefix]= hits
    return rec_orthoNums


def make_Res_orthogroupSuppor(orthogroupNodeInfor):
    if orthogroupNodeInfor.startswith("r"):
        orthogroupNodeInfor = "Orthogroup was delineated by the rearranged node.\n"
        return orthogroupNodeInfor
    elif re.search("B=([\d\.]+)\]", orthogroupNodeInfor):
        match = re.search("B=([\d\.]+)\]", orthogroupNodeInfor)
        bsValue = match.group(1)
        bsValue = re.sub("\.\d+", "", bsValue)
        return "The orthogroup monophyly is supported by " + str(bsValue) + "%"
    else:
        return orthogroupNodeInfor


def error_makeSummary(resultFN):
    fs = open(eachDirAddress + "100_1stAnalysisSummary.txt", "w")

    fs.write("################ Results ################\n\n")
    fs.write(">Result\n")
    fs.write(resultFN + "\n");
    fs.write("\n")

    uploadedSEQfn = readFasta_dict(eachDirAddress, "000_uploaded.txt")
    fs.write(">Querys_used_in_the_analysis\n")
    fs.write(write_querySeq(uploadedSEQfn))
    fs.write("\n")

    fs.close()


def makeSummary():

    uploadedSEQfn = readFasta_dict(eachDirAddress, "000_uploaded.txt")
    cDNAfn = ""
    if querySeqChr == "nucl":
        cDNAfn               = readFasta_dict(eachDirAddress, "000_cDNAQuery.txt")
    recAAfn              = readFasta_dict(eachDirAddress, "000_aaQuery.txt")
    rec044_unambSiteRate = readFasta_dict(eachDirAddress, "044_unambSiteRate.txt")

    fs = open(eachDirAddress + "100_1stAnalysisSummary.txt", "w")

    fs.write("################ Results ################\n\n")

    fs.write(">Querys_used_in_the_analysis\n")
    fs.write(write_querySeq(uploadedSEQfn))
    fs.write("\n")

    speciesTree = ""
    if reconciliation == "treeSearchRearrange":

        f1stTree = open(eachDirAddress + "085_NJBS1st.txt.rearrange.0")
        treeNHX = list(f1stTree)[0]
        f1stTree.close()

        f1stTree = open(eachDirAddress + "000_uploadedTree.txt")
        speciesTree = "".join(list(f1stTree))
        speciesTree = re.sub("[ \n]", "", speciesTree)
        f1stTree.close()

        allClades   = cladesCollectFromNHX(treeNHX)
        orthoGroup = orthoGroupIdentifyFromNHX(treeNHX)
        orthogroupNodeInfor = ""
        if orthoGroup[0] == 0:
            fs.write(">Orthogroup:\n")
            orthoGroupTMP = orthoGroup[2]
            orthoGroupTMP = re.sub("<br>", "\n", orthoGroupTMP)
            fs.write(orthoGroupTMP + "\n")
        else:
            fs.write(">Result\n")
            Res_orthogroupSuppor = make_Res_orthogroupSuppor(orthoGroup[2])
            fs.write(Res_orthogroupSuppor + "\n")
            fs.write("\n")

            fs.write(">Orthogroup\n")
            #for dbLine in dbLines:
            #    hitLeaves = [leaf for leaf in orthoGroup[1]if re.search(dbLine[0], leaf)]
            #    for leaf in hitLeaves:
            #        fs.write(leaf + "\n")
            orthoGroupOrderd = sorted(orthoGroup[1])
            for leaf in orthoGroupOrderd:
                fs.write(leaf + "\n")
            fs.write("\n")
            
            match = re.search("S=([^:]+):", orthoGroup[2])
            nodeName_orthogroup = match.group(1)
            #print nodeName_orthogroup
            #exit()
            topHits = topHitPicker()
            topHitName_1stQuery = list(topHits.values())[0][0]
            spNamePrefixes_orthoGroup  = make_cladeSpNamePrefixes(speciesTree, [nodeName_orthogroup], topHitName_1stQuery)
            rec_orthoNums = leafCountFromSpNamePrefix(orthoGroup, spNamePrefixes_orthoGroup)
            rec_orthoNums = whiteSpaceAdd(rec_orthoNums)
            fs.write(">Number_of_orthologs\n")
            for name, num in rec_orthoNums.items():
                fs.write(name + ":" + str(num) + "\n")
            fs.write("\n")

            focalGroup = ""
            sisterGroup = ""
            daughterGroup1st, daughterGroup2nd = daughterGroupsIdentify(allClades, orthoGroup)
            if topHitName_1stQuery[1:] in daughterGroup1st[1]:
                focalGroup  = daughterGroup1st
                sisterGroup = daughterGroup2nd
            else:
                focalGroup  = daughterGroup2nd
                sisterGroup = daughterGroup1st
            
            '''
            fs.write(">Focalgroup\n")
            #for dbLine in dbLines:
                #hitLeaves = [leaf for leaf in focalGroup[1] if re.search(dbLine[0], leaf)]
                #for leaf in hitLeaves:
                #    fs.write(leaf + "\n")
            focalGroupSorted = sorted(focalGroup[1])
            for leaf in focalGroupSorted:
                fs.write(leaf + "\n")
            fs.write("\n")

            fs.write(">Sistergroup\n")
            #for dbLine in dbLines:
                #hitLeaves = [leaf for leaf in sisterGroup[1]if re.search(dbLine[0], leaf)]
                #for leaf in hitLeaves:
                #    fs.write(leaf + "\n")
            sisterGroupSorted = sorted(sisterGroup[1])
            for leaf in sisterGroupSorted:
                fs.write(leaf + "\n")
            '''

        fs.write("\n")

        fs.write(">Rearranged_gene_tree_newick\n")
        rearrangedTreeNewick = nhx2NewickWithNHXnodeName(treeNHX)
        fs.write(rearrangedTreeNewick)
        fs.write("\n")

        fs.write(">Rearranged_gene_tree_nhx\n")
        fs.write(treeNHX)
        fs.write("\n")

    fs.write(">Gene_tree_newick\n")
    f1stTree = open(eachDirAddress + "085_NJBS1st.txt")
    fs.write(list(f1stTree)[0])
    f1stTree.close()
    fs.write("\n")

    rec044_unambSiteRate = whiteSpaceAdd(rec044_unambSiteRate)
    fs.write(">Aligned-site_rate\n")
    for name, siteRate in rec044_unambSiteRate.items():
        nameRate = name + ":" + str(siteRate)
        if float(siteRate) > nonGapSiteRate:
            fs.write(nameRate + "\n")
        else:
            fs.write("== Removed ==> " + nameRate + "\n")
    fs.write("\n")

    fs.write(">AnalysisTime\n")
    elapsed_time = round((time.time() - startTime),1)
    fs.write (str(elapsed_time) + " seconds")
    fs.write("\n\n")

    fs.write("\n################ Settings ################\n\n")

    fs.write(">AnalysisGroup\n")
    fs.write(analysisGroupName + "\n")
    fs.write("\n")

    fs.write(">Uploaded_your_sequences\n")
    for name, seq in uploadedSEQfn.items():
        name = re.sub("[\n\r]", "", name)
        fs.write(name[1:] + "\n")
        fs.write(seq + "\n")
    fs.write("\n")

    if reconciliation == "treeSearchRearrange":
        fs.write(">SpeciesTree\n")
        fs.write(speciesTree)
    fs.write("\n\n")

    fs.write(">Genomes_used_in_the_analysis\n")
    for dbLine in dbLines:
        fs.write(dbLine[0][:-1] + "\n")
    fs.write("\n")

    fs.write(">E-value_threshold_for_reported_sequences\n"  + str(blastEvalue)  + "\n\n")
    fs.write(">Number_of_hits_to_report_per_genome\n" + str(blastTopHits) + "\n\n")
    fs.write(">TreeSearchMethod\n"   + "Neighbor-joining method (Saitou and Nei 1986)\n\n")

    if querySeqChr == "nucl":
        if dataset == "Exclude3rd":
            fs.write(">SubstitutionModel\n" + "F84 (Tamura and Nei 1993) + gamma\n\n")
        elif dataset == "Include3rd":
            fs.write(">SubstitutionModel\n" + "TN93 (Tamura and Nei 1993) + gamma\n\n")
        else:
            fs.write(">SubstitutionModel\n" + "WAG (Whelan and Goldman 2001) + gamma\n\n")
    else:
        fs.write(">SubstitutionModel\n" + "WAG (Whelan and Goldman 2001) + gamma\n\n")

    fs.write(">Aligned_site_rate_threshold_in_Unambiguously_aligned_sites\n" + str(nonGapSiteRate) + "\n\n")

    fs.write(">Dataset\n" + dataset +  "\n")
    fs.write("\n")

    if reconciliation == "treeSearchRearrange":
        fs.write(">Rearrangement_BS_value_threshold\n")
        fs.write(str(RearrangementBSthreshold) + "\n")
        fs.write("\n")

    fs.write(">Dependencies\n")
    fs.write("BLAST 2.7.1+\n")
    fs.write("MAFFT v7.356b\n")
    fs.write("trimAl 1.2rev59\n")
    fs.write("ape in R, Version: 5.0\n")
    if reconciliation == "treeSearchRearrange":
        fs.write("Notung-2.9\n")
    fs.write("\n")

    fs.close()
    
### makeSummary End


### Blast Start
def blastResDeleter():
    for dbline in dbLines:
        if not "xxxxxx" in dbline[3]:
            os.remove(eachDirAddress + dbline[3])


#def cDNARecPicker(nameLine, dirAddressFN, dbCDNAfile):
#
#    nameLine = nameLine.rstrip("\n")
#    cdnaID = re.sub(r"^.*transcript:", "", nameLine)
#    cdnaID = re.sub(r" .*$", "", cdnaID)
#    cdnaID = cdnaID.rstrip("\n")
#    cdnaID = ">" + cdnaID + " "
#    #print "    nameLine: ", nameLine, "<br>"
#    #print "    cdnaID: ", cdnaID, "<br>"
#    #print "    dbCDNAfile: ", dbCDNAfile, "<br>"
#    #print "<br>"
#    recCDNA = readFasta_dict(dirAddressFN, dbCDNAfile)
#    hitName = [name for name in recCDNA.keys() if name.startswith(cdnaID)]
#    if len(hitName) > 1:
#        print("    Error: >2 cDNA seq:", nameLine)
#        print("    in :", dbCDNAfile)
#        exit();
#    if len(hitName) == 1:
#        #print("    len(hitName):", len(hitName))
#        #print("    hitName:", hitName)
#        return (hitName[0]+"\n", recCDNA[hitName[0]]+"\n")
#    else:
#        print("    Error: No hits:", nameLine)
#        print("    in :", dbCDNAfile)
#        exit();


def uniqueList(listAll):
    names_uniq = []
    for x in listAll:
        if x not in names_uniq:
            names_uniq.append(x)
    return names_uniq


def select_blastHitUnique(blastResFileFN):
    f = open(eachDirAddress + blastResFileFN)
    blastResAllLines = list(f)
    f.close()
    nameLinesAll = []
    nameLineAdd = ""
    flag = 0
    for line in blastResAllLines:
        line = line.rstrip("\n")
        if line.startswith("Length"):
            nameLineAdd = re.sub("^> ", ">", nameLineAdd)
            nameLinesAll.append(nameLineAdd)
            nameLineAdd = ""
            flag = 0
        if flag == 1:
            nameLineAdd += line
        if line.startswith(">"):
            flag = 1
            nameLineAdd += line
    return uniqueList(nameLinesAll)


def hitRecPicker():
    blastResOut = open(eachDirAddress + "010_blastRes.txt",        "w")
    AAout       = open(eachDirAddress + "030_retrievedAAfas.txt",  "w")
    CDNAout = ""
    if querySeqChr == "nucl":
        CDNAout     = open(eachDirAddress + "030_retrievedDNAfas.txt", "w")

    #'''
    num_BlastpHits = 0
    for dbline in dbLines:

        recdbAA = readFasta_dict(dbAddress, dbline[1])
        recdbDNA = ""
        if querySeqChr == "nucl":
            recdbDNA = readFasta_dict(dbAddress, dbline[2])

        blastResFile   = dbline[3]
        #print("blastResFile:", blastResFile)
        uniqueHitLines = select_blastHitUnique(blastResFile)

                
        for line in reversed(uniqueHitLines):
            if not line.startswith(">"):
                continue
            ################################### Blast hit delete START
            #if re.search(">LanceletC_BRBE143570F-t", line):
            #    #print("LanceletC_BRBE143570F-t skipped.")
            #    continue
            #if re.search(">LanceletC_BRBE239040R-t1", line):
            #    continue
            #if re.search("> Drosophila_FBpp0309625_Retinal-Homeobox", line):
            #    continue
            ################################### Blast hit delete END
            
            num_BlastpHits += 1
            
            blastResOut.write(line + "\n")
            line = line.rstrip("\n")
            #print "line:", line
            #print "<br>"
            match = re.search("DBNLINE\|(\d+)\|", line)
            DBNLINEnum = match.group(1)
            #print "DBNLINEnum:", DBNLINEnum, "<br>"
            #print list(recdbAA.keys())[int(DBNLINEnum)], "<br><br>"
            name_AA = list(recdbAA.keys())[int(DBNLINEnum)]
            #name_AA = re.sub("(>.{60}).*", r"\1", name_AA)
            AAout.write  (name_AA                                  + "\n")
            AAout.write  (list(recdbAA.values())[int(DBNLINEnum)]  + "\n")
            if querySeqChr == "nucl":
                CDNAout.write(list(recdbDNA.keys())[int(DBNLINEnum)]   + "\n")
                CDNAout.write(list(recdbDNA.values())[int(DBNLINEnum)] + "\n")
            
            #print()
    blastResOut.close()

    #print "num_BlastpHits:", num_BlastpHits
    if num_BlastpHits < 4:
        result = "Error: Blastp hits was less than 4."
        error_makeSummary(result)
        print (result + " <br>")
        error_resHtmlMaker(result)
        exit()

    recsAA_queryFile   = readFasta_dict(eachDirAddress, "000_aaQuery.txt")
    recsCDNA_queryFile = ""
    if querySeqChr == "nucl":
        recsCDNA_queryFile = readFasta_dict(eachDirAddress, "000_cDNAQuery.txt")

    if reconciliation == "treeSearchRearrange":

        spNames_IndbLines = make_spNames_IndbLines()
        for i in reversed(range(len(recsAA_queryFile))):
            nameLine = list(recsAA_queryFile.keys())[i]
            #print("nameLine:", nameLine)
            match = re.search(">([^_]+)_([^_]+)_", nameLine)
            spName = match.group(1)
            #protID = match.group(2)
            if not spName in spNames_IndbLines:
                #print("spNamePrefix_queryFile:", spNamePrefix_queryFile)
                #print("protID_queryFile:", protID_queryFile)
                #AAout.write(">" + spName + "_" + protID + "_NONE cds gene:" + protID + " transcript:" + protID + " \n")
                AAout.write(nameLine + " \n")
                AAout.write(list(recsAA_queryFile.values())[i] + "\n")
                #CDNAout.write(">" + protID + " cds gene:" + protID + " \n")
                if querySeqChr == "nucl":
                    CDNAout.write(nameLine + " \n")
                    CDNAout.write(list(recsCDNA_queryFile.values())[i] + "\n")
    else:
        for i in reversed(range(len(recsAA_queryFile))):
            #nameLine = list(recsAA_queryFile.keys())[i]
            #match = re.search(">([^_]+)_([^_]+)_", nameLine)
            #spName = match.group(1)
            #protID       = match.group(2)
            #AAout.write(">" + spName + "_" + protID + "_NONE cds gene:" + protID + " transcript:" + protID + " \n")
            AAout.write(list(recsAA_queryFile.keys())[i] + "\n")
            AAout.write(list(recsAA_queryFile.values())[i] + "\n")
            #CDNAout.write(">" + protID + " cds gene:" + protID + " \n")
            if querySeqChr == "nucl":
                CDNAout.write(list(recsCDNA_queryFile.keys())[i] + "\n")
                CDNAout.write(list(recsCDNA_queryFile.values())[i] + "\n")

    AAout.close()
    if querySeqChr == "nucl":
        CDNAout.close()


def make_spNames_IndbLines():
    spNames_IndbLines = []
    for dbLine in dbLines:
        spNamePrefix_dbLine = dbLine[0]
        spNamePrefix_dbLine = re.sub("_$", "", spNamePrefix_dbLine)
        spNames_IndbLines.append(spNamePrefix_dbLine)
    return spNames_IndbLines


def blastpSearch():
    DirAafileName = eachDirAddress + "000_aaQuery.txt"

    for dbline in dbLines:
        dbAAfile = dbAddress      + dbline[1]
        outFile  = eachDirAddress + dbline[3]
        #comLine =                       "yuraiScripts/blastall -p blastp         -i {0}          -e {1}        -b {2}             -v {3}                 -d {4}      -o {5}"\
        #                                                                .format(DirAafileName,   blastEvalue, blastTopHits,      blastTopHits,          dbAAfile,   outFile)
        comLine =                                    "blastp     -query {0}      -evalue {1}    -num_alignments {2}  -num_descriptions {3}  -db {4}      -out {5}"\
                                                                       .format(DirAafileName,   blastEvalue, blastTopHits,        blastTopHits,          dbAAfile,    outFile)

        #print("comLine:", comLine)
        #exit()
        subprocess.call(comLine, shell=True)


def blastResQueryHitPicker(nameLine):

    #print("nameLine2:", nameLine)
    match = re.search(">([^_]+)_", nameLine)
    speciesNamePrefix = match.group(1)

    topHit = ""
    identity = ""

    spNames_IndbLines = make_spNames_IndbLines()

    if not speciesNamePrefix in spNames_IndbLines:
        topHit = nameLine
    else:
        blastOutFileName = "005_out_vs" + speciesNamePrefix + ".txt"
        #print("blastOutFileName:", blastOutFileName)
        f = open(eachDirAddress + blastOutFileName)
        lines = list(f)
        f.close()
        flag = 0
        for line in lines:

            spNameProtID = nameLine
            #print spNameProtID, "<br>"
            spNameProtID = re.sub(">([^_]+_[^_]+)_.*$", r"\1", spNameProtID)
            key = "^Query= " + spNameProtID
            #print key, "<br>"
            #exit()

            if flag == 1:
                if line.startswith(">"):
                    topHit = line
                    topHit = re.sub("^> ",">", topHit)
                    topHit = re.sub(" .*$","", topHit)
                    topHit = topHit.rstrip("\n")

                if line.startswith(" Identities ="):
                    match = re.search("(Identities =[^,]+),", line)
                    identity = match.group(1)
                    break

            if re.search(key, line):
                flag = 1

        if not topHit:
            topHit = ">" + speciesNamePrefix + "_XXXX_NoBlastHit"

    return topHit, identity


def write_querySeq(uploadedSEQfn):
    topHits = topHitPicker()
    topHitValue0s = [x[0] for x in topHits.values()]
    longestNameInDBLen       = len(max(topHitValue0s, key = len))
    #longestuploadedCDNAfnLen = len(max(uploadedSEQfn.keys(), key = len))
    for i in range(len(topHits)):
        uploadedSeqName = list(uploadedSEQfn.keys())[i][1:]
        #print("uploadedSeqName:", uploadedSeqName)
        #print("list(topHits.values())[i][1:]:", list(topHits.values())[i][1:])
        #print("\n")
        uploadedSeqName = re.sub("[\n\r]", "", uploadedSeqName)
        #print("list(topHits.values())[i][0]", list(topHits.values())[i][0])
        #exit()
        if reconciliation == "treeSearchRearrange":
            InfoIdentity = list(topHits.values())[i][1]
            if not InfoIdentity:
                InfoIdentity = "Name"
            #fs.write(list(topHits.values())[i][0][1:] \
            return(list(topHits.values())[i][0][1:] \
                     + " " * (longestNameInDBLen - len(list(topHits.values())[i][0][1:])) \
                     + " <= " \
                     + "[" + InfoIdentity + "] "\
                     + " " * (30 - len(InfoIdentity)) \
                     + ": "+ uploadedSeqName \
                     #+ " " * (longestuploadedCDNAfnLen - len(uploadedSeqName)) \
                     + "\n")
        else:
            InfoIdentity = "Name"
            #fs.write(list(topHits.values())[i][0][1:] \
            return(list(topHits.values())[i][0][1:] \
                     + " " * (longestNameInDBLen - len(list(topHits.values())[i][0][1:])) \
                     + " <= " \
                     + "[" + InfoIdentity + "] "\
                     + ": "+ uploadedSeqName \
                     + "\n")

def topHitPicker():
    topHits = OrderedDict()

    recs_SEQ = ""
    if querySeqChr == "nucl":
        recs_SEQ = readFasta_dict(eachDirAddress, "000_cDNAQuery.txt")
    else:
        recs_SEQ = readFasta_dict(eachDirAddress, "000_aaQuery.txt")
    for nameLine, seq in recs_SEQ.items():
        if reconciliation == "treeSearchRearrange":
            #print "nameLine:", nameLine, "<br>"
            blastTopHitNameLine, blastTopHitIdentity = blastResQueryHitPicker(nameLine)
            #print "blastTopHitIdentity:", blastTopHitIdentity, "<br>"
            topHits[nameLine] = [blastTopHitNameLine, blastTopHitIdentity.rstrip("\n")]
        else:
            nameLineTMP = re.sub(" .*$","", nameLine)
            #topHits[nameLine] = nameLineTMP
            topHits[nameLine] = [nameLineTMP, 1]
    return topHits


### Blast End


### seqSelect_nonGapSitesEnoughLong Start
def compare2seqs(querySeq, otherSeq):
    count = 0
    for i in range(len(querySeq)):
        #if re.match(querySeq[i], "[-Xx]") and re.match(querySeq[i], "[-Xx]"):
        #    print("  NOT")
        #elif re.match(querySeq[i], "[-Xx]") and re.match(querySeq[i], "\w"):
        #    print("  COUNT")
        #    count += 1
        #if re.match(querySeq[i], "\w") and re.match(querySeq[i], "\w"):
        if re.match("\w", querySeq[i]) and re.match("\w", otherSeq[i]):
            #print("  COUNT")
            count += 1
        elif re.match("-", querySeq[i]) and re.match("\w", otherSeq[i]):
            #print("querySeq[i]:", querySeq[i])
            #print("otherSeq[i]:", otherSeq[i])
            #print("  COUNT")
            count += 1
        else:
            #print("querySeq[i]:", querySeq[i])
            #print("otherSeq[i]:", otherSeq[i])
            #print("  NOT")
            continue
    return round(float(count)/len(querySeq),3)


def calculate_nonGapSiteRate(trimledAAfile):
    recs_nonGapSiteRateFN = OrderedDict()
    recAA = readFasta_dict(eachDirAddress, trimledAAfile)

    querySeq = list(recAA.values())[-1]
    for otherName, otherSeq in recAA.items():
        protID = re.sub(" .*$","", otherName)
        aaRate = compare2seqs(querySeq, otherSeq)
        recs_nonGapSiteRateFN[protID] = aaRate
    return recs_nonGapSiteRateFN


def seqSelect_nonGapSitesEnoughLong():

    recs_nonGapSiteRate = calculate_nonGapSiteRate("042_AA.fas.trm")

    file_overRateAA        = open(eachDirAddress + "044_overRateAA.fas", "w")
    file_overRateDNA       = ""
    if querySeqChr == "nucl":
        file_overRateDNA       = open(eachDirAddress + "044_overRateDNA.fas", "w")
    file_unambSiteRatefile = open(eachDirAddress + "044_unambSiteRate.txt", "w")

    recAA      = readFasta_dict(eachDirAddress, "030_retrievedAAfas.txt")
    recDNA     = ""
    if querySeqChr == "nucl":
        recDNA     = readFasta_dict(eachDirAddress, "030_retrievedDNAfas.txt")
    for i in range (len(recs_nonGapSiteRate)):
        name = list(recs_nonGapSiteRate.keys())[i]
        rate = list(recs_nonGapSiteRate.values())[i]
        if rate > nonGapSiteRate:
            file_overRateAA.write  (list(recAA.keys())[i]    + "\n")
            file_overRateAA.write  (list(recAA.values())[i]  + "\n")
            if querySeqChr == "nucl":
                file_overRateDNA.write(list(recDNA.keys())[i]   + "\n")
                file_overRateDNA.write(list(recDNA.values())[i] + "\n")
        file_unambSiteRatefile.write(name + "\n" + str(rate) + "\n")
    file_overRateAA.close()
    if querySeqChr == "nucl":
        file_overRateDNA.close()
    file_unambSiteRatefile.close()

    
### seqSelect_nonGapSitesEnoughLong End


### alignmentFile_PhyAnal Start
def orderedDict2FasFile(recs, outfile):
    out           = open(eachDirAddress + outfile, "w")
    for name,value in recs.items():
        out.write(name + "\n")
        out.write(value + "\n")
    out.close()

def orderedDict2phyFile(recs, outfile):
    secLength     = len(sorted(recs.values())[0])
    spSeqSizeLine = str(len(recs)) + " " + str(secLength)

    recs = whiteSpaceAdd(recs)
    out           = open(eachDirAddress + outfile, "w")
    out.write(spSeqSizeLine + "\n")
    for name,value in recs.items():
        out.write(name + value + "\n")
    out.close()


def read_TrimalHTMLout_dict(trimAAresult):
    f = open(eachDirAddress + trimAAresult)
    lines = list(f)
    f.close()

    recs_trimalHTMLout  = OrderedDict()
    for line in lines:
        if line.startswith("    <span class=sel>"):
            line = line.rstrip("\n")
            match = re.search("<span class=sel>([^<]+)</span> +([^ ].*)$", line)
            name     = match.group(1)
            sequence = match.group(2)
            if not name in recs_trimalHTMLout.keys():
                recs_trimalHTMLout[name] = ""
            recs_trimalHTMLout[name] += sequence

    #for name, seq in recs_trimalHTMLout.items():
    #    print(name)
    #    print(seq)
    #exit()
    return recs_trimalHTMLout
    


def trimaledFileMakerDNA(fastaFile, trimAAresult):
    recs = readFasta_dict(eachDirAddress, fastaFile)
    #for name, seq in recs.items():
    #    print(name)
    #    print(seq)
    
    recs_trimalHTMLout    = read_TrimalHTMLout_dict(trimAAresult)
    trimalMarkedSites = list(recs_trimalHTMLout.values())[-1]
    trimalMarkedSites = re.sub("<span class=sel>.</span>", "#", trimalMarkedSites)

    recsTrimed = OrderedDict()
    for name,value in recs.items():
        sequence = ""
        for i in range(len(trimalMarkedSites)):
            if trimalMarkedSites[i] == "#":
                #out.write(trimalMarkedSites[i])
                sequence += value[i*3] + value[i*3+1] + value[i*3+2]
        recsTrimed[name] = sequence
    orderedDict2phyFile(recsTrimed, outfile = "080_trimedCDNAPhy.txt")

    #recsTrimedExc3rd = OrderedDict()
    #for name,value in recsTrimed.items():
    #    seqeucneExc3rd = ""
    #    for i in range(len(value)):
    #        if i % 3 == 0 or i % 3 == 1:
    #            seqeucneExc3rd += value[i]
    #    recsTrimedExc3rd[name] = seqeucneExc3rd
    #orderedDict2phyFile(recsTrimedExc3rd, outfile = "080_trimeExc3rdPhy.txt")

### alignmentFile_PhyAnal End


### alignmentFile_HTML
def outGroupSelect (phyFileName):
    recSeqFN = readPhy_dict(phyFileName)
    outgroupTMP = list(recSeqFN.keys())[0]
    return outgroupTMP[1:]

def reorderSeqByTree(recsFN, treeFileName):
    leaves = []
    leaves = leafCollectInOrderFrom_bothNHXnewick(treeFileName)
    seqDictFN  = OrderedDict()
    for leaf in reversed(leaves):
        Lleaf = ">" + leaf
        seqDictFN[Lleaf] = recsFN[Lleaf]
    return seqDictFN

def trimAlresReader(inFileAAFN):
    aafile = open(eachDirAddress + inFileAAFN, "r")
    aafileLines = list(aafile)
    aafile.close()
    
    sequenceTMP = ""
    name_firstRec = ""
    for line in aafileLines:
        if re.search("    <span class=sel>[^<]+<", line):
            match = re.search("    <span class=sel>([^<]+)<", line)
            name_firstRec = match.group(1)
            break
    for line in aafileLines:
        if re.search("<span class=sel>" + name_firstRec + "<", line):
            line = re.sub("^ +<span class=sel>" + name_firstRec + "</span> +", "", line).rstrip("\n")
            line = re.sub("<span class=sel>.</span>", "#", line)
            sequenceTMP += line

    sequence = ""
    for chr in sequenceTMP:
        codon = ""
        if chr == "#":
            codon = "111"
        else:
            codon = "000"
        sequence += codon

    if sequence:
        return sequence
    else:
        print("No key sequence line in :", inFileAAFN)
        print("  searched by :", topHitName_1stQuery[1:])
        exit()

#def addSiteNotes(inFileAAFN, recsFN):
#    seqDictFN  = OrderedDict()
#    sequence_tm = trimAlresReader(inFileAAFN)
#    seqDictFN[">Used_sites_NONE"] = sequence_tm
#    for name, value in recsFN.items():
#      seqDictFN[name] = value
#    return seqDictFN
    
#def speciesColorStyleAdd(recsFN1):
#    recsFN2 = OrderedDict()
#    for name, value in recsFN1.items():
#        nameStyled = ""
#        for dbEle in dbLines:
#            if re.search(dbEle[0], name):
#                nameStyled = "<span class=" + dbEle[5] +">" + name[1:] + "</span>"
#                break
#        if nameStyled:
#            recsFN2[nameStyled] = value
#        else:
#            recsFN2[name[1:]] = value
#    return recsFN2

def delete_nameSpaceSeqBp(recsFN):
    recsFN2        = OrderedDict()
    for name, seq in recsFN.items():
        if re.search(" \d+ bp$", name):
            name = re.sub(" \d+ bp$", "", name)
        recsFN2[name] = seq
    return recsFN2

def arrowheadDelete(recsFN):
    recsFN2        = OrderedDict()
    for name, seq in recsFN.items():
        if name.startswith(">"):
            recsFN2[name[1:]] = seq
        else:
            recsFN2[name] = seq
    return recsFN2

def nameChange_whiteLaterDelete(recsFN):
    recsFN2        = OrderedDict()
    for name, seq in recsFN.items():
        name = re.sub(" .*$", "", name)
        recsFN2[name] = seq
    return recsFN2

def gapDelete(recsFN):
    recsFN2        = OrderedDict()
    for name, seq in recsFN.items():
        seq = re.sub("-", "", seq)
        recsFN2[name] = seq
    return recsFN2


def whiteSpaceAdd(recsFN1):
    longestName = max(recsFN1.keys(), key = len)
    longestName = re.sub("<[^>]+>", "", longestName)
    longestNameLen = len(longestName)
    recsFN2        = OrderedDict()
    for name,value in recsFN1.items():
        name = re.sub("^>", "", name)
        nameTMP = re.sub("<[^>]+>", "", name)
        nameWhiteSpace = name + " " * (longestNameLen - len(nameTMP) + 2)
        recsFN2[nameWhiteSpace] = value
    return recsFN2

def keySequencePicker(topHitName_1stQuery, recsFN):
    hitNames = [name for name in recsFN.keys() if re.search(topHitName_1stQuery[1:], name)]
    if len(hitNames) > 1:
        print("More than 2 keySpecies:%s. Stopped." % topHitName_1stQuery[1:])
        exit()
    elif len(hitNames) == 0:
        print("No keySpecies:%s. Stopped." % topHitName_1stQuery[1:])
        exit()
    else:
        return recsFN[hitNames[0]]

def matchFirsterCodon (keyCodonFN, nameFN, codonFN):
    codonFNmod = ""
    nameFN = ">" + nameFN
    topHits = topHitPicker()
    topHitName_1stQuery = list(topHits.values())[0][0]
    #print("topHitName_1stQuery", topHitName_1stQuery)
    #exit()
    if re.search(topHitName_1stQuery, nameFN):
        codonFNmod = codonFN
    else:
        for i in range(0,3):
            if keyCodonFN[i] == "X" or keyCodonFN[i] == "-" or keyCodonFN[i] == "N":
                codonFNmod += codonFN[i]
            elif keyCodonFN[i] == codonFN[i]:
                codonFNmod += "."
            else:
                codonFNmod += codonFN[i]
    return codonFNmod

def codonHTMLpicker(keySpCodonFN, nameFN, codonFN):
    codonMatchFirsted = ""
    
    if re.search("\d\d\d", codonFN) or re.search("-", codonFN):
        codonMatchFirsted = codonFN
    else:
        codonMatchFirsted = geneticCodeHTML.get(codonFN, "CODON")
        codonFN2          = matchFirsterCodon(keySpCodonFN, nameFN, codonFN)
        codonMatchFirsted = re.sub("CODON", codonFN2, codonMatchFirsted)
    return codonMatchFirsted

#def recOneLinesMaker(topHitName_1stQuery, keySequenceFN, startPosNF, stopPosNF, recsFN):
#
#    htmlOneLines = []
#
#    longestName    = max(recsFN.keys(), key = len)
#    longestName    = re.sub("<[^>]+>", "", longestName)
#    longestNameLen = len(longestName)
#    NumberLine     = " " * (longestNameLen) + str(startPosNF+1) + "\n"
#    htmlOneLines.append(NumberLine)
#
#    for name in recsFN.keys():
#        htmlOneLine = name
#        for p in range(startPosNF, stopPosNF, 3):
#            if p+2 <= stopPosNF:
#                keySpCodon   = keySequenceFN[p] + keySequenceFN[p+1] + keySequenceFN[p+2]
#                codon        = recsFN[name][p]  + recsFN[name][p+1]  + recsFN[name][p+2]
#                codonHTML    = codonHTMLpicker(keySpCodon, name, codon)
#                htmlOneLine += codonHTML
#        
#        if re.search(topHitName_1stQuery[1:], name):
#            htmlOneLine = "<u>" + htmlOneLine + "</u>"
#        else:
#            spName = re.sub("[^_]+_[^_]+$", "", name)
#            htmlOneLine = "<span class=" + spName + ">" + htmlOneLine + "</span>"
#
#        htmlOneLine += "\n"
#        htmlOneLines.append(htmlOneLine)
#
#    return htmlOneLines

#def codonHTMLfileMaker(oneLineLengthFN, recsFN, outFileFN):
#
#    topHits = topHitPicker()
#    topHitName_1stQuery = list(topHits.values())[0]
#    topHitSeq_1stQuery  = keySequencePicker(topHitName_1stQuery, recsFN)
#
#    siteNum  = 1
#    startPos = 0
#    stopPos  = 0
#    sequenceLength = len(topHitSeq_1stQuery)
#    #print("sequenceLength:", sequenceLength)
#    out = open(eachDirAddress + outFileFN, "w")
#    if analysisGroupName == "Protostomia": 
#        out.write(alignHTMLtop_protostomes)
#    elif analysisGroupName == "Deuterostomia": 
#        out.write(alignHTMLtop)
#    elif analysisGroupName == "Vertebrata": 
#        out.write(alignHTMLtop_vertebrates)
#    else:
#        out.write(alignHTMLtop_teleosts)
#    out.write(str(len(recsFN)) + " " + str(sequenceLength) + "\n")
#    for i in range(sequenceLength):
#        if i > 1 and i % oneLineLengthFN == 0:
#            startPos = i - oneLineLengthFN
#            stopPos = startPos + oneLineLengthFN
#            #print("siteNum :", startPos + 1)
#            #print("startPos:", startPos)
#            #print("stopPos :", stopPos)
#            #for j in range(startPos, stopPos):
#            #    print(str(j) + ",", end="")
#            #print()
#            recOneLines = recOneLinesMaker(topHitName_1stQuery, topHitSeq_1stQuery, startPos, stopPos, recsFN)
#            for line in recOneLines:
#                out.write(line)
#            out.write("\n")
#
#    #print("siteNum :", stopPos + 1)
#    #print("startPos:", stopPos)
#    #print("stopPos :", sequenceLength)
#    #for i in range(stopPos, sequenceLength):
#    #    print(str(i) + ",", end="")
#    #print()
#    recOneLines = recOneLinesMaker(topHitName_1stQuery, topHitSeq_1stQuery, stopPos, sequenceLength, recsFN)
#    for line in recOneLines:
#        out.write(line)
#    out.write(alignHTMLbottom)
#    out.close()

#def cDNAaligHtmlMaker(inFile, inFileAA, tree4leafOrder, outFile):
#    oneLineLength = 90         ## For cDNA, needs to be a multiple of 3
#    recs        = readFasta_dict(eachDirAddress, inFile)
#    recs        = reorderSeqByTree(recs, tree4leafOrder)
#    recs        = addSiteNotes(inFileAA, recs)
#    recs        = whiteSpaceAdd(recs)
#    codonHTMLfileMaker(oneLineLength, recs, outFile)

def reorderDeleteGap_Fas2FasByTree(fastaFileName, tree4leafOrder, outPhyFileName):
    recs = readFasta_dict(eachDirAddress,fastaFileName) 
    recs = nameChange_whiteLaterDelete(recs)
    recs = gapDelete(recs)
    recs = reorderSeqByTree(recs, tree4leafOrder)
    orderedDict2FasFile(recs, outfile = outPhyFileName)

def phy2fastmePhy(phyFileName, outFastmePhyFileName):
    recsFN = readPhy_dict(phyFileName)
    secLength     = len(sorted(recsFN.values())[0])
    spSeqSizeLine = str(len(recsFN)) + " " + str(secLength)

    recsFN = whiteSpaceAdd(recsFN)
    out  = open(eachDirAddress + outFastmePhyFileName, "w")
    out.write(spSeqSizeLine + "\n")
    for name,value in reversed(recsFN.items()):
        out.write(name + value + "\n")
    out.close()


def fas2phy(fastaFileName, outPhyFileName):
    recs = readFasta_dict(eachDirAddress,fastaFileName)
    recs = delete_nameSpaceSeqBp(recs)
    orderedDict2phyFile(recs, outfile = outPhyFileName)

def reorderFas2PhyByTree(fastaFileName, tree4leafOrder, outPhyFileName):
    recs = readFasta_dict(eachDirAddress,fastaFileName) 
    recs = delete_nameSpaceSeqBp(recs)
    for name, seq in recs.items():
        print(name)
        print("<br><br>")
    exit()
    recs = reorderSeqByTree(recs, tree4leafOrder)
    #recs = arrowheadDelete(recs)
    orderedDict2phyFile(recs, outfile = outPhyFileName)

def reorderPhyFileByTree(phyFileName, tree4leafOrder, outPhyFileName):
    recs = readPhy_dict(phyFileName) 
    #print(recs.values())
    recs = reorderSeqByTree(recs, tree4leafOrder)
    #recs = arrowheadDelete(recs)
    #recs = whiteSpaceAdd(recs)
    orderedDict2phyFile(recs, outfile = outPhyFileName)

def codonSepalate(recs):
    recs1 = OrderedDict()
    recs2 = OrderedDict()
    recs3 = OrderedDict()
    for name, sec in recs.items():
        recs1[name] = ""
        recs2[name] = ""
        recs3[name] = ""
        for i in range(len(sec)):
            if   i%3 == 0:
               recs1[name] += sec[i]
            elif i%3 == 1:
               recs2[name] += sec[i]
            else:
               recs3[name] += sec[i]
    return recs1, recs2, recs3

def phyCodonToBlock(phyFileName, blockNum, outfile):
    recs = readPhy_dict(phyFileName)
    recs1, recs2, recs3 = codonSepalate(recs)
    recsS1 = OrderedDict()
    if blockNum == 3:
        for name in recs1.keys():
            recsS1[name] = recs1[name] + recs2[name] + recs3[name]
            
    if blockNum == 2:
        for name in recs1.keys():
            recsS1[name] = recs1[name] + recs2[name]

    #recsS1   = arrowheadDelete(recsS1)
    recsS2 = whiteSpaceAdd(recsS1)

    out = open(eachDirAddress + outfile, "w")
    out.write(str(len(recsS2)) + " " + str(len(list(recsS2.values())[0])) + "\n")
    for name,sec in recsS2.items():
        out.write(name + sec + "\n")
    out.close()

#def raxmlInfileMake(outComFile, outPartFile):
#    phyFile = open(eachDirAddress + "240_reorderedTrimedBlockInc3rdPhy.txt", "r")
#    phyLines = list(phyFile)
#    phyFile.close() 
#    spNumTMP, seqLength = re.split(" ",  phyLines[0])
#    outgroup, seqTMP    = re.split(" +", phyLines[1])
#    
#    comFile = open(eachDirAddress + outComFile, "w")
#    comFile.write("./raxmlHPC-PTHREADS-SSE3_Mac -f a -x 12345 -p 12345 -# 100 -m GTRGAMMA -s 030_alnCodonBlock_trimedInc3rd.txt -q raxml_Part.txt -o " + outgroup + " -n outfile -T 2\n")
#    comFile.write("#./raxmlHPC-PTHREADS-SSE3_Mac -f a -x 12345 -p 12345 -# 100 -m PROTGAMMAWAGF -s 030_aln_trimedAA.txt -o " + outgroup + " -n outfile -T 2\n")
#    comFile.close()
#
#    seqLength = int(seqLength)
#    partFile = open(eachDirAddress + outPartFile, "w")
#    partFile.write("DNA,gene1=1-"                                    + str(int(seqLength/3)) + "\n")
#    partFile.write("DNA,gene2=" + str(int(seqLength/3)     + 1)     + "-" + str((int(seqLength/3))*2)   + "\n")
#    partFile.write("DNA,gene3=" + str((int(seqLength/3))*2 + 1)     + "-" + str(seqLength)   + "\n")
#    partFile.close()

### alignmentFile_HTML End

### result_HTML Start
def error_resHtmlMaker(resultFN):
    topHits = topHitPicker()
    topHitName_1stQuery = list(topHits.values())[0]
    resHTMLlines1 = re.sub('FIRSTQUERY', topHitName_1stQuery[0][1:], resHTMLlines_error)
    resHTMLlines1 = re.sub('RESULTMESSAGE', resultFN, resHTMLlines1)

    if analysisGroupName == "Protostomia":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: protostome orthogroup', resHTMLlines1)
    elif analysisGroupName == "Deuterostomia":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: deuterostome orthogroup', resHTMLlines1)
    elif analysisGroupName == "Vertebrata":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: vertebrate orthogroup', resHTMLlines1)
    else:
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: actinopterygian orthogroup', resHTMLlines1)
    if reconciliation == "treeSearchRearrange":
        resHTMLlines1 = re.sub("REARRANGED_TREE",  '<img src="115_1stRearranged_geneTree.png">', resHTMLlines1)
    else:
        resHTMLlines1 = re.sub(".*REARRANGED.*\n", "", resHTMLlines1)

    out = open(eachDirAddress + "300_resultsREA.html", "w")
    out.write(resHTMLlines1)
    out.close()

def resHtmlMaker():
    
    topHits = topHitPicker()
    topHitName_1stQuery = list(topHits.values())[0]
    resHTMLlines1 = re.sub('FIRSTQUERY', topHitName_1stQuery[0][1:], resHTMLlines)

    if reconciliation == "treeSearchRearrange":
        f1stTree = open(eachDirAddress + "085_NJBS1st.txt.rearrange.0")
        treeNHX = list(f1stTree)[0]
        f1stTree.close()
        orthoGroup = orthoGroupIdentifyFromNHX (treeNHX)
        
        Res_orthogroupSuppor = make_Res_orthogroupSuppor(orthoGroup[2])
        Res_orthogroupSuppor = Res_orthogroupSuppor
        #print("downloadLine:", downloadLine)
        resHTMLlines1 = re.sub('RESULTMESSAGE', Res_orthogroupSuppor, resHTMLlines1)
    else:
        resHTMLlines1 = re.sub('.*RESULTMESSAGE.*', '', resHTMLlines1)

    downloadFileName = "result" + str(countFileName) + ".zip"
    downloadMessage = 'Download: <a href="' + downloadFileName + '">' + downloadFileName + '</a>.'
    resHTMLlines1 = re.sub('DOWNLOADMESSAGE', downloadMessage, resHTMLlines1)

    if analysisGroupName == "Protostomia":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: protostome orthogroup', resHTMLlines1)
    elif analysisGroupName == "Deuterostomia":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: deuterostome orthogroup', resHTMLlines1)
    elif analysisGroupName == "Vertebrata":
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: vertebrate orthogroup', resHTMLlines1)
    else:
        resHTMLlines1 = re.sub("TITLE",  'ORTHOSCOPE: actinopterygian orthogroup', resHTMLlines1)
    if reconciliation == "treeSearchRearrange":
        resHTMLlines1 = re.sub("REARRANGED_TREE",  '<img src="115_1stRearranged_geneTree.png">', resHTMLlines1)
    else:
        resHTMLlines1 = re.sub(".*REARRANGED.*\n", "", resHTMLlines1)
    out = open(eachDirAddress + "300_resultsREA.html", "w")
    out.write(resHTMLlines1)
    out.close()

def compression():
    resDirName = eachDirAddress + "result" + str(countFileName)
    os.mkdir   (resDirName)
    shutil.copy(eachDirAddress + "100_1stAnalysisSummary.txt",              resDirName + "/000_summary.txt")
    shutil.copy(eachDirAddress + "042_AA.fas.trm.html",                     resDirName + "/010_aln_prot.html")
    #shutil.copy(eachDirAddress + "087_inroot100Tree.outfile.nwk",          resDirName + "/020_tree.txt")
    if os.path.isfile(eachDirAddress + "115_1stGeneTree.pdf"):
        shutil.copy(eachDirAddress + "115_1stGeneTree.pdf",                     resDirName + "/020_tree.pdf")
    else:
        shutil.copy(eachDirAddress + "115_1stGeneTree.png",                     resDirName + "/020_tree.png")
    if reconciliation == "treeSearchRearrange":
        shutil.copy(eachDirAddress + "115_1stRearranged_geneTree.pdf",      resDirName + "/020_treeRearranged.pdf")

    shutil.copy(eachDirAddress + "240_reorderedAAfas.txt",                   resDirName + "/010_candidates_prot.txt")
    if querySeqChr == "nucl":
        shutil.copy(eachDirAddress + "240_reorderedCDNAfas.txt",                 resDirName + "/010_candidates_nucl.txt")

    #shutil.copy(eachDirAddress + "240_reorderedCDNAphy.txt",                resDirName + "/020_aln_nucl.txt")
    #shutil.copy(eachDirAddress + "230_CDNA.html",                           resDirName + "/020_aln_nucl.html")
    #shutil.copy(eachDirAddress + "240_reorderedTrimedAAPhy.txt",            resDirName + "/030_aln_trimedAA.txt")
    #shutil.copy(eachDirAddress + "240_reorderedTrimedCDNAphy.txt",          resDirName + "/030_aln_trimedCDNA.txt")
    #shutil.copy(eachDirAddress + "240_reorderedTrimedBlockExc3rdPhy.txt",   resDirName + "/030_alnCodonBlock_trimedExc3rd.txt")
    #shutil.copy(eachDirAddress + "240_reorderedTrimedBlockInc3rdPhy.txt",   resDirName + "/030_alnCodonBlock_trimedInc3rd.txt")

    shutil.copy(dirAddress + "orthoscope/examples/100_2ndTree.zip",           resDirName + "/100_2ndTree.zip")

    zipfiles = glob.glob(resDirName + '/*')
    fzip = zipfile.ZipFile(resDirName + '.zip', 'w', zipfile.ZIP_DEFLATED)
    for file in zipfiles:
        fzip.write(file, os.path.basename(file))
    fzip.close()
### result_HTML End


### Count

def makeCount():
    import fcntl
    
    dat = "./yuraiScripts/count.dat"
    
    fh = open(dat, "r+")
    fcntl.flock(fh.fileno(), fcntl.LOCK_EX)

    count = fh.read()
    count = int(count)
    count += 1
    count = str(count)

    fh.seek(0)
    fh.write(count)
    fcntl.flock(fh.fileno(), fcntl.LOCK_UN)

    fh.close()
    return count

###


######################################################################################################################
#################################### Main program ####################################################################
######################################################################################################################



#########################
### from HTML
import sys

infile_dir     = "querySeqFiles"
infileName_seq = sys.argv[1]
infileName_tree = "SpeciesTreeHypothesisP.tre"

print ("\n\n\n\n###### " + infileName_seq + "######\n\n")
startTime = time.time()
#countFileName = makeCount()
#countFileName = startTime

#eachDirAddress, taxonSamplingList, querySeqChr, blastEvalue, blastTopHits, nonGapSiteRate, dataset, RearrangementBSthreshold, analysisGroupName, reconciliation = uploadedFileSave(cgi.FieldStorage())

#####
### from terminal

#'''##### time fixed
countFileName = 1528339855

outdir = "020_outdir"



##eachDirAddress = "../Documents/yuraiWork/" + str(countFileName) + "/"
#eachDirAddress = "../html/yuraiWork/" + str(countFileName) + "/"


blastEvalue    = 1e-3
blastTopHits   = 5   #
nonGapSiteRate = 0  #0.45
querySeqChr = "nucl"
#dataset        = "Include3rd"
dataset        = "Exclude3rd"
RearrangementBSthreshold = 60
#taxonSamplingList  = ['Celegans_', 'Silkworm_', 'Drosophila_', 'AcornWormS_', 'AcornWormP_', 'SeaUrchinS_', 'AcanthasterGbr_', 'LanceletF_', 'LanceletC_', 'Oikopleura_', 'Botryllus_', 'CionaS_', 'CionaI_', 'Gar_', 'Medaka_', 'Xenopus_', 'Anole_', 'Chicken_', 'Human_']
taxonSamplingList  = [
                      "Nematostella-vectensis_", 
                      "Praesagittifera-naikaiensis_",
                      "Lottia-gigantea_", 
                      "Pinctada-fucata_", 
                      "Caenorhabditis-elegans_", 
                      'Drosophila-melanogaster_', 
                      "Saccoglossus-kowalevskii_",
                      "Ptychodera-flava_",
                      "Strongylocentrotus-purpuratus_",
                      "Acanthaster-planci_",
                      "Branchiostoma-floridae_",
                      "Branchiostoma-belcheri_",
                      "Oikopleura-dioica_",
                      "Botryllus-schlosseri_",
                      "Ciona-savignyi_",
                      'Ciona-savignyi_', 
                      'Gallus-gallus_', 
                      'Homo-sapiens_'
                      ]
analysisGroupName = "Deuterostomia"
#reconciliation = "treeSearchOnly"
reconciliation = "treeSearchRearrange"
#####

#infileName_seqTMP = re.sub("\..*$", "", infileName_seq)
#eachDirAddress = outdir + "/" + infileName_seqTMP + "/"
eachDirAddress = outdir + "/" + infileName_seq + "/"

dirFileMake(infile_dir + "/" + infileName_seq, infileName_tree)

#'''#########################

#rm_command = "find " + dirAddress + "yuraiWork/ -mtime +1 -type d -exec rm -r {} \;"
#subprocess.call(rm_command, shell=True)

dbLines = dbLinesMake()
nodeNames_ancestral = get_nodeNames_ancestral()

#for dbLine in dbLines:
#  print(dbLine[0])
#  print("<br><br>")
#exit()


'''
'''

checkUplodedFileAsFastaForamt()

if querySeqChr == "nucl":
    cDNAqueryFileMaker()


allNodes = []
if reconciliation == "treeSearchRearrange":
    allNodes = TEST_querySpIsInTree()

aaSeqMaker()


##print("### blast: 010_blastRes.txt 030_retrievedAAfas.txt 030_retrievedDNAfas.txt<br>")
blastpSearch()


hitRecPicker()
#blastResDeleter()



##print("### mafft: 040_mafOutAA.txt<br>")
#maffLine1 = "yuraiScripts/mafft " + eachDirAddress + "030_retrievedAAfas.txt > " + eachDirAddress + "040_mafOutAA.txt"
maffLine1 = "mafft " + eachDirAddress + "030_retrievedAAfas.txt > " + eachDirAddress + "040_mafOutAA.txt"
#print("maffLine1", maffLine1)
subprocess.call(maffLine1, shell=True)
##print("<br>")


##print("### trimal: 042_AA.fas.trm<br>")
trimLine1 = "trimal -out " + eachDirAddress + "042_AA.fas.trm -htmlout " + eachDirAddress + "042_AA.fas.trm.html -in " + eachDirAddress + "040_mafOutAA.txt -gappyout"
#print("trimLine1:", trimLine1, "\n");
subprocess.call(trimLine1, shell=True)


##print("### seqSelect_nonGapSitesEnoughLong: 044_overRateAA.fas 044_unambSiteRate.txt 044_overRateDNA.fas<br>")
seqSelect_nonGapSitesEnoughLong()


##print("### mafft: 050_retAAseqs.maf\n")
#maffLine2 = "yuraiScripts/mafft " + eachDirAddress + "044_overRateAA.fas > " + eachDirAddress + "050_retAAseqs.maf"
maffLine2 = "mafft " + eachDirAddress + "044_overRateAA.fas > " + eachDirAddress + "050_retAAseqs.maf"
##print(maffLine2)
subprocess.call(maffLine2, shell=True)
##print("<br><br>")

#print("### trimal: 052_AA.fas.trm.html<br>")
trimLine2 = "trimal -out " + eachDirAddress + "052_AA.fas.trm -htmlout " + eachDirAddress + "052_AA.fas.trm.html -in " + eachDirAddress + "050_retAAseqs.maf -gappyout"
#print(trimLine2, "\n");
subprocess.call(trimLine2, shell=True)
##print("<br><br>")



##print("### pal2nal: 054_p2nOutcDNAfas.txt<br>")
pal2nalLine = "pal2nal.pl " + eachDirAddress + "050_retAAseqs.maf " + eachDirAddress + "044_overRateDNA.fas -output fasta > " + eachDirAddress +"054_p2nOutcDNAfas.txt"
#print (pal2nalLine)
subprocess.call(pal2nalLine, shell=True)
#print("<br>")


if querySeqChr == "nucl":
    trimaledFileMakerDNA("054_p2nOutcDNAfas.txt", "052_AA.fas.trm.html")

    #print("### phyCodonToBlock: 082_trimedBlockInc3rdPhy.txt")
    phyCodonToBlock("080_trimedCDNAPhy.txt", 2, outfile="082_trimedBlockExc3rdPhy.txt")
    phyCodonToBlock("080_trimedCDNAPhy.txt", 3, outfile="082_trimedBlockInc3rdPhy.txt")

    phy2fastmePhy(phyFileName="082_trimedBlockExc3rdPhy.txt", outFastmePhyFileName="082_trimedBlockExc3rdFastmePhy.txt")
    phy2fastmePhy(phyFileName="082_trimedBlockInc3rdPhy.txt", outFastmePhyFileName="082_trimedBlockInc3rdFastmePhy.txt")

fas2phy(fastaFileName="052_AA.fas.trm", outPhyFileName="080_trimedAAPhy.txt")
phy2fastmePhy(phyFileName="080_trimedAAPhy.txt", outFastmePhyFileName="082_trimedAAFastmePhy.txt")



### NJ
outgroup1 = outGroupSelect("080_trimedAAPhy.txt")
if querySeqChr == "nucl":
    if dataset == "Exclude3rd":
        #NJBSline1 = "yuraiScripts/fastme -i " + eachDirAddress + "082_trimedBlockExc3rdFastmePhy.txt -d F84 -m BioNJ -b 100 -v 3 -o " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085_fastmelog.txt"
        NJBSline1 = "Rscript yuraiScripts/NJBS.R " + eachDirAddress + "082_trimedBlockExc3rdPhy.txt " + outgroup1 + " " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085log.txt"
    elif dataset == "Include3rd":
        #NJBSline1 = "yuraiScripts/fastme -i " + eachDirAddress + "082_trimedBlockInc3rdFastmePhy.txt -d F84 -m BioNJ -b 100 -v 3 -o " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085_fastmelog.txt"
        NJBSline1 = "Rscript yuraiScripts/NJBS.R " + eachDirAddress + "082_trimedBlockExc3rdPhy.txt " + outgroup1 + " " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085log.txt"
    else:
        NJBSline1 = "fastme -i " + eachDirAddress + "082_trimedAAFastmePhy.txt --protein=WAG -m NJ -b 100 -v 3 -o " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085_fastmelog.txt"
else:
    NJBSline1 = "fastme -i " + eachDirAddress + "082_trimedAAFastmePhy.txt --protein=WAG -m NJ -b 100 -v 3 -o " + eachDirAddress + "085_NJBS1st.txt > " + eachDirAddress + "085_fastmelog.txt"

#print ("NJBSline1: ", NJBSline1)
subprocess.call(NJBSline1, shell=True)


if not os.path.isfile(eachDirAddress + "085_NJBS1st.txt"):
    print ("Tree Error1: Cannot estimate the NJ tree.<br>")
    print ("Please just push Execute again.<br>")
    print ("Sometimes bootstrap analysis produces unavailab alignment.<br>")
    exit()

NJtreeFile = open(eachDirAddress + "085_NJBS1st.txt")
NJtreeFileCont = list(NJtreeFile)
if not NJtreeFileCont:
    print ("Tree Error2: Cannot estimate the NJ tree.")
    exit()


if reconciliation == "treeSearchRearrange":

    #print("### 210_Notung-2.6.jar: 085_NJBS1st.txt.rearrange.0")
    NOTUNG1stLine = "java -jar yuraiScripts/Notung-2.9.jar -s " + eachDirAddress + "000_uploadedTree.txt -g " + eachDirAddress + "085_NJBS1st.txt --outputdir " + eachDirAddress + " --rearrange --threshold " + str(RearrangementBSthreshold) + " --speciestag prefix  --maxtrees 5 --nolosses --treeoutput nhx > " + eachDirAddress + "085_NOTUNGlog.txt"
    #print("NOTUNG1stLine:", NOTUNG1stLine)
    subprocess.call(NOTUNG1stLine, shell=True)

    if not os.path.isfile(eachDirAddress + "085_NJBS1st.txt.rearrange.0"):
        print ("Error in NOTUNG: Cannot compare the NJ and species tree.<br>")
        print ("Check your species tree.<br>")
        exit()


############## Printout
##print("### makeSummary:100_1stAnalysisSummary.txt")

makeSummary()


treePlotR = "Rscript yuraiScripts/treePlot.R " + eachDirAddress + "100_1stAnalysisSummary.txt " + analysisGroupName + " " + eachDirAddress + "115_1st > " + eachDirAddress + "115_logTreePlotB.txt"
#print("treePlotR: ", treePlotR)
subprocess.call(treePlotR, shell=True)

#print("### cDNAaligHtmlMaker: 230_CDNA.html<br>")
#print("### reorderFas2PhyByTree: 240")
tree4leafOrder = ""
if reconciliation == "treeSearchRearrange":
    tree4leafOrder = "115_1stRearranged_geneTree.txt"
else:
    tree4leafOrder = "085_NJBS1st.txt"

##### takes long time ######
#####  cDNAaligHtmlMaker("054_p2nOutcDNAfas.txt", "052_AA.fas.trm.html", tree4leafOrder, outFile = "230_CDNA.html")
##############

## Raw seqs
reorderDeleteGap_Fas2FasByTree("050_retAAseqs.maf",             tree4leafOrder, outPhyFileName="240_reorderedAAfas.txt")
if querySeqChr == "nucl":
    reorderDeleteGap_Fas2FasByTree("054_p2nOutcDNAfas.txt",         tree4leafOrder, outPhyFileName="240_reorderedCDNAfas.txt")

#reorderFas2PhyByTree("052_AA.fas.trm",               tree4leafOrder, outPhyFileName="240_reorderedTrimedAAPhy.txt")
#reorderFas2PhyByTree("054_p2nOutcDNAfas.txt",        tree4leafOrder, outPhyFileName="240_reorderedCDNAphy.txt")
#rorderPhyFileByTree("080_trimedCDNAPhy.txt",        tree4leafOrder, outPhyFileName="240_reorderedTrimedCDNAphy.txt")
#reorderPhyFileByTree("082_trimedBlockExc3rdPhy.txt", tree4leafOrder, outPhyFileName="240_reorderedTrimedBlockExc3rdPhy.txt")
#reorderPhyFileByTree("082_trimedBlockInc3rdPhy.txt", tree4leafOrder, outPhyFileName="240_reorderedTrimedBlockInc3rdPhy.txt")

#print("### raxmlInfileMake: 270_raxmlCom.txt, 270_raxmlPartition.txt")
#raxmlInfileMake(outComFile="270_raxmlCom.txt", outPartFile="270_raxmlPart.txt")

#print("### compression: result....zip")
#print("test finished.")
#exit()
#compression()


#print("### resHtmlMaker: 300_resultsREA.html<br>")
resHtmlMaker()
##print("<br><br>")

### https://qiita.com/fantm21/items/3dc7fbf4e935311488bc
#elapsed_time = round((time.time() - startTime),1)
#print ("Analysis time: {0}".format(elapsed_time) + " seconds")

#htmlAddress = '<br>Finished: <a href="http://fish-evol.unit.oist.jp/yuraiWork/' + str(countFileName) + '/300_resultsREA.html" target="_blank">result' + str(countFileName) + '</a><br><br>'
#htmlAddress = '<br>Finished: <a href="http://localhost/yuraiWork/'              + str(countFileName) + '/300_resultsREA.html" target="_blank">result' + str(countFileName) + '</a><br><br>'

#print(htmlAddress)
#print ("Analysis finished.<br>")


exit()
