library(ape)
args             <- commandArgs()
infileName       <- args[6]      # 100_1stAnalysisSummary.txt
analysisGroupName    <- args[7]
outfileName      <- args[8]      # 115_1st


################# Node name
nodeNameLabel_change_swich <- "on"
#nodeNameLabel_change_swich <- "off"
#########################

redPrefixes <- c(); greenPrefixes <- c(); purplePrefixes <- c(); orangePrefixes <- c(); magentaPrefixes <-c(); bluePrefixes <- c()
if (analysisGroupName == "Protostomia") {
  greenPrefixes   <- c('Adineta-vaga_','Schistosoma-mansoni_','Capitella-teleta_','Helobdella-robusta_','Notospermus-geniculatus_','Phoronis-australis_','Lingula-anatina_')
  purplePrefixes  <- c('Octopus-bimaculoides_','Lottia-gigantea_','Biomphalaria-glabrata_','Aplysia-californica_','Crassostrea-virginica_','Crassostrea-gigas_','Mizuhopecten-yessoensis_','Pinctada-fucata_')
  orangePrefixes  <- c('Priapulus-caudatus_','Trichinella-spiralis_','Strongyloides-ratti_','Onchocerca-volvulus_','Loa-loa_','Brugia-malayi_','Pristionchus-pacificus_','Caenorhabditis-japonica_','Caenorhabditis-elegans_','Caenorhabditis-brenneri_','Caenorhabditis-remanei_','Caenorhabditis-briggsae_')
  magentaPrefixes     <- c('Limulus-polyphemus_','Sarcoptes-scabiei_','Tetranychus-urticae_','Ixodes-scapularis_','Centruroides-sculpturatus_','Parasteatoda-tepidariorum_','Stegodyphus-mimosarum_')
  bluePrefixes    <- c('Strigamia-maritima_','Hyalella-azteca_','Eurytemora-affinis_','Lepeophtheirus-salmonis_','Daphnia-magna_','Daphnia-pulex_','Pediculus-humanus_','Zootermopsis-nevadensis_','Cryptotermes-secundus_','Rhodnius-prolixus_','Acyrthosiphon-pisum_','Nasonia-vitripennis_','Atta-cephalotes_','Solenopsis-invicta_','Apis-mellifera_','Bombus-impatiens_','Bombus-terrestris_','Tribolium-castaneum_','Anoplophora-glabripennis_','Dendroctonus-ponderosae_','Bombyx-mori_','Heliconius-melpomene_','Danaus-plexippus_','Melitaea-cinxia_','Belgica-antarctica_','Culex-quinquefasciatus_','Aedes-aegypti_','Anopheles-darlingi_','Mayetiola-destructor_','Megaselia-scalaris_','Teleopsis-dalmanni_','Lucilia-cuprina_','Drosophila-grimshawi_','Drosophila-mojavensis_','Drosophila-virilis_','Drosophila-willistoni_','Drosophila-pseudoobscura_','Drosophila-persimilis_','Drosophila-ananassae_','Drosophila-yakuba_','Drosophila-erecta_','Drosophila-simulans_','Drosophila-sechellia_','Drosophila-melanogaster_')
} else if (analysisGroupName == "Deuterostomia") {
  redPrefixes     <- c('Praesagittifera-naikaiensis_')
  greenPrefixes   <- c('Ptychodera-flava_','Saccoglossus-kowalevskii_')
  purplePrefixes  <- c('Strongylocentrotus-purpuratus_', 'Acanthaster-planci_', 'Acanthaster-planciGBR_')
  orangePrefixes  <- c('Branchiostoma-floridae_','Branchiostoma-belcheri_')
  magentaPrefixes     <- c('Oikopleura-dioica_', 'Botryllus-schlosseri_', 'Ciona-intestinalis_', 'Ciona-savignyi_')
  bluePrefixes    <- c('Petromyzon-marinus_','Callorhinchus-milii_','Rhincodon-typus_','Lepisosteus-oculatus_','Scleropages-formosus_','Paramormyrops-kingsleyae_','Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_','Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_','Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_','Latimeria-chalumnae_','Xenopus-tropicalis_','Xenopus-laevis_','Gekko-japonicus_','Anolis-carolinensis_','Pogona-vitticeps_','Python-bivittatus_','Thamnophis-sirtalis_','Protobothrops-mucrosquamatus_','Pelodiscus-sinensis_','Chrysemys-picta_','Chelonia-mydas_','Alligator-mississippiensis_','Alligator-sinensis_','Ficedula-albicollis_','Anas-platyrhynchos_','Meleagris-gallopavo_','Taeniopygia-guttata_','Gallus-gallus_','Ornithorhynchus-anatinus_','Monodelphis-domestica_','Sarcophilus-harrisii_','Notamacropus-eugenii_','Loxodonta-africana_','Trichechus-manatus_','Procavia-capensis_','Orycteropus-afer_','Echinops-telfairi_','Dasypus-novemcinctus_','Choloepus-hoffmanni_','Erinaceus-europaeus_','Sorex-araneus_','Pteropus-vampyrus_','Myotis-lucifugus_','Equus-caballus_','Ceratotherium-simum_','Manis-javanica_','Felis-catus_','Canis-familiaris_','Mustela-putorius-furo_','Leptonychotes-weddellii_','Ailuropoda-melanoleuca_','Ursus-maritimus_','Camelus-bactrianus_','Vicugna-pacos_','Sus-scrofa_','Odocoileus-virginianus_','Bubalus-bubalis_','Bison-bison_','Bos-taurus_','Ovis-aries_','Capra-hircus_','Balaenoptera-acutorostrata_','Physeter-catodon_','Lipotes-vexillifer_','Tursiops-truncatus_','Orcinus-orca_','Otolemur-garnettii_','Microcebus-murinus_','Propithecus-coquereli_','Carlito-syrichta_','Aotus-nancymaae_','Callithrix-jacchus_','Cebus-capucinus_','Saimiri-boliviensis-boliviensis_','Nomascus-leucogenys_','Pongo-abelii_','Gorilla-gorilla_','Pan-troglodytes_','Pan-paniscus_','Homo-sapiens_','Colobus-angolensis-palliatus_','Rhinopithecus-roxellana_','Rhinopithecus-bieti_','Chlorocebus-sabaeus_','Papio-anubis_','Cercocebus-atys_','Mandrillus-leucophaeus_','Macaca-nemestrina_','Macaca-fascicularis_','Macaca-mulatta_','Tupaia-belangeri_','Oryctolagus-cuniculus_','Ochotona-princeps_','Ictidomys-tridecemlineatus_','Fukomys-damarensis_','Heterocephalus-glaber_','Octodon-degus_','Chinchilla-lanigera_','Cavia-porcellus_','Cavia-aperea_','Dipodomys-ordii_','Jaculus-jaculus_','Nannospalax-galili_','Peromyscus-maniculatus_','Cricetulus-griseus_','Rattus-norvegicus_','Mus-pahari_','Mus-spretus_','Mus-musculus_')
} else if (analysisGroupName == "Vertebrata") {
  greenPrefixes   <- c('Petromyzon-marinus_','Callorhinchus-milii_','Rhincodon-typus_')
  purplePrefixes  <- c('Lepisosteus-oculatus_','Scleropages-formosus_','Paramormyrops-kingsleyae_','Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_','Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_','Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_')
  orangePrefixes  <- c('Latimeria-chalumnae_','Xenopus-tropicalis_','Xenopus-laevis_','Gekko-japonicus_','Anolis-carolinensis_','Pogona-vitticeps_','Python-bivittatus_','Thamnophis-sirtalis_','Protobothrops-mucrosquamatus_')
  magentaPrefixes     <- c('Pelodiscus-sinensis_','Chrysemys-picta_','Chelonia-mydas_','Alligator-mississippiensis_','Alligator-sinensis_','Ficedula-albicollis_','Anas-platyrhynchos_','Meleagris-gallopavo_','Taeniopygia-guttata_','Gallus-gallus_')
  bluePrefixes    <- c('Ornithorhynchus-anatinus_','Monodelphis-domestica_','Sarcophilus-harrisii_','Notamacropus-eugenii_','Loxodonta-africana_','Trichechus-manatus_','Procavia-capensis_','Orycteropus-afer_','Echinops-telfairi_','Dasypus-novemcinctus_','Choloepus-hoffmanni_','Erinaceus-europaeus_','Sorex-araneus_','Pteropus-vampyrus_','Myotis-lucifugus_','Equus-caballus_','Ceratotherium-simum_','Manis-javanica_','Felis-catus_','Canis-familiaris_','Mustela-putorius-furo_','Leptonychotes-weddellii_','Ailuropoda-melanoleuca_','Ursus-maritimus_','Camelus-bactrianus_','Vicugna-pacos_','Sus-scrofa_','Odocoileus-virginianus_','Bubalus-bubalis_','Bison-bison_','Bos-taurus_','Ovis-aries_','Capra-hircus_','Balaenoptera-acutorostrata_','Physeter-catodon_','Lipotes-vexillifer_','Tursiops-truncatus_','Orcinus-orca_','Tupaia-belangeri_','Oryctolagus-cuniculus_','Ochotona-princeps_','Ictidomys-tridecemlineatus_','Fukomys-damarensis_','Heterocephalus-glaber_','Octodon-degus_','Chinchilla-lanigera_','Cavia-porcellus_','Cavia-aperea_','Dipodomys-ordii_','Jaculus-jaculus_','Nannospalax-galili_','Peromyscus-maniculatus_','Cricetulus-griseus_','Rattus-norvegicus_','Mus-pahari_','Mus-spretus_','Mus-musculus_','Otolemur-garnettii_','Microcebus-murinus_','Propithecus-coquereli_','Carlito-syrichta_','Aotus-nancymaae_','Callithrix-jacchus_','Cebus-capucinus_','Saimiri-boliviensis-boliviensis_','Colobus-angolensis-palliatus_','Rhinopithecus-roxellana_','Rhinopithecus-bieti_','Chlorocebus-sabaeus_','Papio-anubis_','Cercocebus-atys_','Mandrillus-leucophaeus_','Macaca-nemestrina_','Macaca-fascicularis_','Macaca-mulatta_','Nomascus-leucogenys_','Pongo-abelii_','Gorilla-gorilla_','Pan-troglodytes_','Pan-paniscus_','Homo-sapiens_')
} else {
  greenPrefixes   <- c('Lepisosteus-oculatus_')
  purplePrefixes  <- c('Scleropages-formosus_','Paramormyrops-kingsleyae_')
  orangePrefixes  <- c('Clupea-harengus_','Ictalurus-punctatus_','Astyanax-mexicanus_','Pygocentrus-nattereri_','Danio-rerio_','Sinocyclocheilus-grahami_','Cyprinus-carpio_')
  magentaPrefixes     <- c('Esox-lucius_','Salmo-salar_','Salvelinus-alpinus_','Oncorhynchus-mykiss_','Oncorhynchus-tshawytscha_','Oncorhynchus-kisutch_')
  bluePrefixes    <- c('Gadus-morhua_','Gasterosteus-aculeatus_','Notothenia-coriiceps_','Larimichthys-crocea_','Labrus-bergylta_','Tetraodon-nigroviridis_','Takifugu-rubripes_','Cynoglossus-semilaevis_','Paralichthys-olivaceus_','Lates-calcarifer_','Seriola-lalandi-dorsalis_','Seriola-dumerili_','Stegastes-partitus_','Amphiprion-ocellaris_','Acanthochromis-polyacanthus_','Oreochromis-niloticus_','Neolamprologus-brichardi_','Pundamilia-nyererei_','Maylandia-zebra_','Haplochromis-burtoni_','Boleophthalmus-pectinirostris_','Hippocampus-comes_','Monopterus-albus_','Oryzias-latipes_','Oryzias-melastigma_','Nothobranchius-furzeri_','Austrofundulus-limnaeus_','Cyprinodon-variegatus_','Fundulus-heteroclitus_','Xiphophorus-maculatus_','Poecilia-formosa_','Poecilia-reticulata_')
}


#######
line.picker <- function(keyWord)
{
  container <- c()
  frag <- 0
  lineStock <- c()
  for(line in infile$V1) {
    #print(line)

    ### Collect lines 
    if (regexpr('^>', line) < 0) {
      if(frag == 1) {
        lineStock <- c(lineStock, line)
      }
    }
  
   if (regexpr('^>', line) > 0)
   {
      if(frag == 1)
      {
        container <- c(container, lineStock)
        lineStock <- c()
        break
      }

      #keyWord1 <- paste('>',　keyWord,　sep='')
      if (regexpr(keyWord, line) > 0)
      {
        container <- c(container, line)
        frag <- 1
      }

    }
  }
  container <- c(container, lineStock)    
  container <- container[-1]
  return(container)
}

preab.sub <- function (keyWordA)
{
  #print(keyWordA)
  keyWordA <- paste(keyWordA, "$", sep = "")
  keyWordA <- paste(">", keyWordA, sep = "")
  #print(keyWordA)
  #print("### infile$V1 START ###")
  #print(infile$V1)
  #print("### infile$V1 END ###")
  if(any(i <- grep(keyWordA, infile$V1)))
  {
    #print("Found keyWordA")
    #print(keyWordA)
    #print("")
    containerA <- line.picker(keyWordA)
  } else {
    #print("Not Found keyWordA")
    #print(keyWordA)
    #print("")
    # print (paste('  ',keyWordA,' does not exist.', sep=''))
    containerA  <- NULL
  }
  return(containerA)
}


fontNumChange <- function (tr)
{
  tipFontNums              <- rep(1, length(tr$tip.label))
  #fontNum[queryIDNum]     <- 4
  return (tipFontNums)
}


queryNameInversion <- function (tr, queryNames)
{
  queryTipNums <- c()
  for(i in 1:length(tr$tip.label)){
    for (queryName in queryNames){
      if(regexpr(queryName, tr$tip.label[i]) > 0){
        #print(queryName)
        #print(tr$tip.label[i])
        #print("")
        queryTipNums <- c(queryTipNums, i)
      }
    }
  }
  return(queryTipNums)
}


tipColorChange <- function (tr)
{
  orangeNum <- c(); blueNum <- c(); redNum <- NULL; greenNum <- c(); magentaNum <- c(); purpleNum <- c(); humanNum <- c()

  for(i in 1:length(tr$tip.label)){

    for (redPrefix in redPrefixes){
      if(regexpr(redPrefix, tr$tip.label[i]) > 0){
        redNum <- c(redNum,i)
      }
    }

    for (greenPrefix in greenPrefixes){
      if(regexpr(greenPrefix, tr$tip.label[i]) > 0){
        greenNum <- c(greenNum,i)
      }
    }

    for (purplePrefix in purplePrefixes){
      if(regexpr(purplePrefix, tr$tip.label[i]) > 0){
        purpleNum <- c(purpleNum,i)
      }
    }
  
    for (orangePrefix in orangePrefixes){
      if(regexpr(orangePrefix, tr$tip.label[i]) > 0){
        orangeNum <- c(orangeNum,i)
      }
    }
  
    for (magentaPrefix in magentaPrefixes){
      if(regexpr(magentaPrefix, tr$tip.label[i]) > 0){
        magentaNum <- c(magentaNum,i)
      }
    }  
  
    for (bluePrefix in bluePrefixes){
      if(regexpr(bluePrefix, tr$tip.label[i]) > 0){
        blueNum <- c(blueNum,i)
      }
    }
  
  }

  tipColorNums             <- rep("black",length(tr$tip.label))
  tipColorNums[redNum]     <- "red"
  tipColorNums[greenNum]   <- "darkgreen"
  tipColorNums[purpleNum]  <- "purple"
  tipColorNums[orangeNum]  <- "darkorange1"
  tipColorNums[magentaNum] <- "hotpink2"
  tipColorNums[blueNum]    <- "blue"

  return(tipColorNums)
}


nodeNameLabel_change <- function (tr)
{
  for(p in 1:length(tr$node.label)){
    #print(tr$node.label[p])
    tr$node.label[p] <- sub('_.*$', "", tr$node.label[p])   
    #print(tr$node.label[p])
  }
  return(tr)
}


BScolorChange <- function (tr)
{
  #print("Rearrangement_BS_value_threshold")
  #print(Rearrangement_BS_value_threshold)

  BSvalueColors <- NULL
  for(p in 1:length(tr$node.label)){
    if (tr$node.label[p] == "r"){
      BSvalueColors <- c(BSvalueColors, 2)
    #} else if (as.numeric(tr$node.label[p]) < as.numeric(Rearrangement_BS_value_threshold)){
    #  BSvalueColors <- c(BSvalueColors, 2)
    } else {
      BSvalueColors <- c(BSvalueColors, 1)    
    }
  }

#  if (is.null(Rearrangement_BS_value_threshold)){
#  } else {
#    for(p in 1:length(tr$node.label)){
#      if (tr$node.label[p] == "r"){
#      } else {   
#        #print(tr$node.label[p])
#        #print(Rearrangement_BS_value_threshold)
#        #print("\n")
#        #print("tr$node.label[p]")
#        #print(tr$node.label[p])
#        if (as.numeric(tr$node.label[p]) < as.integer(Rearrangement_BS_value_threshold)){
#          BSvalueColors <- c(BSvalueColors, 2) 
#        }
#      }
#    }
#  }


  return(BSvalueColors)
}


edgeWidthChange <- function (tr, OrthoLeaves)
{
  orthoBranchNums <- c()
  for(i in 1:length(tr$tip.label)){
    for(orthoLeaf in OrthoLeaves){
      if (tr$tip.label[i] == orthoLeaf){
        orthoBranchNums <- c(orthoBranchNums, i)
      }
    }
  }

  edgeWidth <- NULL
  if(is.null(orthoBranchNums)){
    edgeWidth          <- rep(1.5, dim(tr$edge)[1])
  } else {
    edgeWidth          <- rep(1.5, dim(tr$edge)[1])
    whOrtho            <- which.edge(tr, orthoBranchNums)
    edgeWidth[whOrtho] <- 4
  }
  return(edgeWidth)
}

PNG_treeDrawing <- function (tr, prefix)
{
  png.file <- paste(outfileName, prefix, sep = "")
  pngWidth <- NULL

  pngHeight <- NULL
  if (length(tr$tip.label) > 200) {
    pngWidth <- 1500
    pngHeight = 2700
  } else if (length(tr$tip.label) > 100) {
    pngWidth <- 1200
    pngHeight = 1800
  } else if (length(tr$tip.label) > 50) {
    pngWidth <- 1000
    pngHeight = 1200
  } else if (length(tr$tip.label) > 10) {
    pngWidth <- 1000
    pngHeight = 900
  } else {
    pngWidth <- 800
    pngHeight = 600
  }

  png(png.file, width = pngWidth, height = pngHeight)
  plot(tr, no.margin=TRUE, underscore = TRUE, use.edge.length=TRUE, cex = 0.9, font = tipFontNums, tip.col = tipColorNums, edge.width = edgeWidth)
  #####nodelabels(tr$node.label, adj = c(1.2,-0.5), frame = "n", font = nodeLabelFontNums, cex=nodeLabelFontSizeNums, col = nodeLabelFontColorNums)
  nodelabels(tr$node.label, adj = c(1.2,-0.5), frame = "n", col = nodeLabelFontColorNums)
  if(!is.null(Num_allQueries)){
    tiplabels (tr$tip.label[Num_allQueries], Num_allQueries, cex=1.0, adj = 0, bg = "gray40", col="white")
  }
  if(!is.null(Num_1stQuery)){
    tiplabels (tr$tip.label[Num_1stQuery],   Num_1stQuery,   cex=1.0, adj = 0, bg = "navyblue", col="white")
  }
  dev.off()
}

PDF_treeDrawing <- function (tr, prefix)
{
  pdf.file <- paste(outfileName, prefix, sep = "")
  pdfWidth  <- NULL
  pdfHeight <- NULL
  if (length(tr$tip.label) > 200) {
    pdfWidth  = 38
    pdfHeight = 28
  } else if (length(tr$tip.label) > 100) {
    pdfWidth  = 31
    pdfHeight = 21
  } else if (length(tr$tip.label) > 50) {
    pdfWidth  = 24
    pdfHeight = 14
  } else if (length(tr$tip.label) > 10) {
    pdfWidth  = 25
    pdfHeight = 10
  } else {
    pdfWidth  = 15
    pdfHeight = 7
  }

  pdf(pdf.file, width = pdfWidth, height = pdfHeight)
  plot      (tr, no.margin=TRUE, underscore = TRUE, use.edge.length=TRUE, cex = 0.9, font = tipFontNums, tip.col = tipColorNums, edge.width = edgeWidth)
  nodelabels(tr$node.label, adj = c(1.2,-0.5), frame = "n", col = nodeLabelFontColorNums)
  if(!is.null(Num_allQueries)){
    tiplabels (tr$tip.label[Num_allQueries], Num_allQueries, cex=1.0, adj = 0, bg = "gray40", col="white")
  }
  if(!is.null(Num_1stQuery)){
    tiplabels (tr$tip.label[Num_1stQuery],   Num_1stQuery, cex=1.0,   adj = 0, bg = "navyblue", col="white")
  }

  dev.off()
}

##################################################################

infile    <- read.table(infileName, na.strings = FALSE, sep = '\t')
Querys_used_in_the_analysis <- preab.sub("Querys_used_in_the_analysis")

queryNames <- c()
for (line in Querys_used_in_the_analysis)
{
  line <- sub(' +.*$', "", line)   
  queryNames <- c(queryNames, line)
}
Orthogroup             <- preab.sub("Orthogroup")

Rearrangement_BS_value_threshold <- c()
Rearrangement_BS_value_threshold <- preab.sub("Rearrangement_BS_value_threshold")


##################################
Gene_tree <- preab.sub("Gene_tree_newick")
Gene_tree <- read.tree(text = Gene_tree)
Gene_tree <- ladderize(Gene_tree, TRUE)
edgeWidth                    <- edgeWidthChange(Gene_tree, Orthogroup)

tipFontNums                  <- fontNumChange(Gene_tree)
tipColorNums                 <- tipColorChange(Gene_tree)
#nodeLabelFontNums           <- rep(1,length(Gene_tree$tip.label))
#nodeLabelFontSizeNums       <- rep(0.9, length(Gene_tree$tip.label))
nodeLabelFontColorNums       <- BScolorChange(Gene_tree)
Num_allQueries               <- queryNameInversion(Gene_tree, queryNames)
Num_1stQuery                 <- queryNameInversion(Gene_tree, queryNames[1])

PNG_treeDrawing(Gene_tree, prefix="GeneTree.png")
PDF_treeDrawing(Gene_tree, prefix="GeneTree.pdf")


##################################
Rearranged_gene_tree <- preab.sub("Rearranged_gene_tree_newick")
if(is.null(Rearranged_gene_tree)) {
  q()
}

Rearranged_gene_tree <- read.tree(text = Rearranged_gene_tree)
Rearranged_gene_tree <- ladderize(Rearranged_gene_tree, TRUE)


edgeWidth              <- edgeWidthChange(Rearranged_gene_tree, Orthogroup)

tipFontNums            <- fontNumChange(Rearranged_gene_tree)
tipColorNums           <- tipColorChange(Rearranged_gene_tree)

nodeLabelFontColorNums <- c()
if (nodeNameLabel_change_swich == "on")
{
  Rearranged_gene_tree     <- nodeNameLabel_change(Rearranged_gene_tree)
  nodeLabelFontColorNums   <- BScolorChange(Rearranged_gene_tree)
}

Num_allQueries             <- queryNameInversion(Rearranged_gene_tree, queryNames)
Num_1stQuery               <- queryNameInversion(Rearranged_gene_tree, queryNames[1])

txt.file <- paste(outfileName, "Rearranged_geneTree.txt", sep = "")
write.tree(Rearranged_gene_tree, file=txt.file)

PNG_treeDrawing(Rearranged_gene_tree, prefix="Rearranged_geneTree.png")
PDF_treeDrawing(Rearranged_gene_tree, prefix="Rearranged_geneTree.pdf")
